function formSubmit(url,formData,inputFieldDetails,formId){
    document.getElementById("submit-btn").disabled = true;
    $('#loadingModal').modal('show');
    $(".invalid-feedback").hide();
    $("#alert-msg").hide();
    $("#alert-success-msg").hide();
    $.ajax({
        url: url,
        type: "POST",
        data:  formData,
        contentType: false,
        cache: false,
        processData:false,
        success: function(data){
            $('#loadingModal').modal('hide');
            document.getElementById("submit-btn").disabled = false;
            let response = JSON.parse(data);  
            //remove errors
            let elements = document.querySelectorAll(".field-error-label");
             elements.forEach(element => {
                element.style.border = "0px solid #fff";
            });  
            let inputField = inputFieldDetails;
            inputField.forEach(ele=>{
                let errElementClear = document.getElementById('invalid-'+ele);
                let inputElementClear = document.getElementById(ele);
                inputElementClear.style.border = "0px solid #fff";
                errElementClear.innerHTML = "";
            })
            //end remove errors
            if(response.status_code == 400){
                $(".invalid-feedback").show();
                Object.keys(response.data).forEach(function(key) {
                   let labelElement = document.getElementById(key+"_label");
                   let inputElement = document.getElementById(key);
                   inputElement.style.border = "1px solid red";
                   labelElement.style.border = "1px solid red";
                   let errors = response.data[key];
                   let errElement = document.getElementById('invalid-'+key);
                   errElement.innerHTML = " ";
                   errors.forEach(value=>{
                     errElement.innerHTML += "<span>"+value+"</span><br/>";
                   })
                });
            }
    
            if(response.status_code == 200){
               $("#alert-success-msg").show();
               document.getElementById(formId).reset();
               document.getElementById('alert-success-msg').innerHTML = response.message;
               setTimeout(()=>{
                if(response.data.redirect){
                    window.location = response.data.redirect;
                }
               },1000)
            }
           
        },
        error: function(xhr, status, error){
            $('#loadingModal').modal('hide');
            $("#alert-msg").show();
            document.getElementById("submit-btn").disabled = false;
            document.getElementById('alert-msg').innerHTML = error;
        } 	        
    });
}


