function formSubmit(url,formData,inputFieldDetails,formId,button="",next=""){
    if(button){
        $("."+button).prop("disabled", true);
    }
    $('#loadingModal').modal('show');
    $(".invalid-feedback").hide();
    $("#alert-msg").hide();
    $("#alert-success-msg").hide();
    
    let returnResponse = true;
    $.ajax({
        url: url,
        type: "POST",
        data:  formData,
        contentType: false,
        cache: false,
        processData:false,
        success: function(data){
            if(button){
                $("."+button).prop("disabled", false);
            }
            $('#loadingModal').modal('hide');
            let response = JSON.parse(data);  
            //remove errors
           
            let inputField = inputFieldDetails;
            inputField.forEach(ele=>{
                let errElementClear = document.getElementById('invalid-'+ele);
                if(errElementClear){
                    errElementClear.innerHTML = "";
                } 
            })
            //end remove errors
            if(response.status_code == 400){
                returnResponse = false;
                $(".invalid-feedback").show();
                Object.keys(response.data).forEach(function(key) {
                   let inputElement = document.getElementById(key);
                   if(inputElement){
                        let errors = response.data[key];
                        let errElement = document.getElementById('invalid-'+key);
                        errElement.innerHTML = " ";
                        errors.forEach(value=>{
                        errElement.innerHTML += "<span>"+value+"</span><br/>";
                        })
                   }
                  
                });
            }
    
            if(response.status_code == 200){
               $("#alert-success-msg").show();
               formId ? document.getElementById(formId).reset() : "";
               document.getElementById('alert-success-msg').innerHTML = response.message;
               if(response.data.id){
                  $('.edit_id').val(response.data.id)
               }
               setTimeout(()=>{
                if(response.data.redirect){
                    window.location = response.data.redirect;
                }
               },1000)
               if(next){
                let tab = document.getElementById(next);
                    if (tab) {
                        tab.click();
                    }
                }
            }
               
           
        },
        error: function(xhr, status, error){
            returnResponse = false;
            $('#loadingModal').modal('hide');
            $("#alert-msg").show();
            if(button){
                $("."+button).prop("disabled", false);
            }
            document.getElementById('alert-msg').innerHTML = error;
        } 	        
    });

    return returnResponse;
}


