<?php
namespace app\src\controllers;

use app\src\core\BaseController;
use app\src\core\Request;
use app\src\core\middlewares\AuthMiddleware;
use app\src\core\Response;
use app\src\models\HomeModel;
use app\src\models\MasterTableModel;
use app\src\models\PersonalModel;
use app\src\models\TheaterModel;
use app\src\core\Application;
use app\src\core\helper\FileUpload\FileUpload;
use Exception;

class TheaterController extends BaseController{

    public function __construct()
    {
        $this->registerMiddleware(new AuthMiddleware(['profile']));
    }
     public function theater_renewal(Request $request,Response $response){
      
      $theater = new TheaterModel();
      $homeModel = new HomeModel;
      $person = new PersonalModel;
      $data = $request->getBody();
     
      if ($request->isPost()) {
          if ($theater->validation($data) && $theater->save($data)) {
            return $response->json(200,"success",['id'=>$theater->theaterId]);
          }else{
            return $response->json(400,"error",$theater->errors);
          } 
      }else{
          $masterTableModel = new MasterTableModel();
          $country_list = $masterTableModel->getAllCountry();
          $states = $masterTableModel->getAllState();
          $cities = $masterTableModel->getAllCity();
          $theater_data = [];
          if(isset($data['id'])){
            $license_id = base64_decode($data['id']);
            $theater_data = $homeModel->getUserApplicationDetails($license_id);
            unset($data["getPoliceDesignations"]);
            unset($data["qry_list"]);
          }
        
          $police_stations = $masterTableModel->getPoliceStations();
          $personalDetails = $person->getPersonalDetails() ? $person->getPersonalDetails()[0] : [];
        
          $is_disable = "";
          if($personalDetails){
            $is_disable = "disabled";
          }
          return $this->render('theater_renewal',['country_list'=>$country_list,'states' => $states,'cities'=>$cities,'police_stations'=>$police_stations,
          'personalDetails'=>$personalDetails,'is_disable'=>$is_disable,"data" => $theater_data]);
      }
        
     }


    public function theater_renewal_docs(Request $request,Response $response){
        if ($request->isPost()) {
             $fileObj = new FileUpload;
             $theater = new TheaterModel();
             $data = $request->getBody();
             $attributes = ["last_renewal_proceedings","fee_details","requisition_letter","certificate_obtained_from_pwd","film_division_certificate",
                  "electrical_certificate","property_tax","entertainemnt_tax","fire_service","affidavit","insurance_policy",
                  "lease_or_rental","public_liability"];

             if(isset($data['theater_id']) && !empty($data['theater_id'])){
                foreach($attributes as $values){
                  if($_FILES[$values]['size'] !== 0 || $_FILES[$values]['error'] == UPLOAD_ERR_OK){
                    $finalData[$values] = $fileObj->upload($_FILES[$values]); 
                  }else{
                    $att = "old_".$values;
                    $finalData[$values] = $data[$att];
                  }
                }
                
                $theater->updateDoc($finalData,$data['theater_id']);
                
                if ($_FILES["other_docs"]['size'][0] !== 0 || $_FILES["other_docs"]['error'][0] == UPLOAD_ERR_OK) {
                    $documents = $fileObj->multiUpload($_FILES['other_docs']);
                    $theater->otherDocSave($documents,$data["theater_id"]);
                }
                return $response->json(200,"success",['id'=>$data['theater_id']]);
                 
             }else{
                  
                  $errors = $fileObj->fileValidation($attributes);
                  $finalData =[];
                  if(empty($data['declaration'])){
                    $errors['declaration'][] = "Please click on the declaration";
                  }
    
                  if (!$fileObj->error && !empty($data['declaration'])) {
                  foreach($attributes as $values){
                    $finalData[$values] = $fileObj->upload($_FILES[$values]);
                  }
                  $attributes[] = 'theatre_information_id';
                  $finalData['theatre_information_id'] = $data["edit_id"];
                  $theater->docSave($finalData,$attributes);
                  if ($_FILES["other_docs"]['size'][0] !== 0 || $_FILES["other_docs"]['error'][0] == UPLOAD_ERR_OK) {
                      $documents = $fileObj->multiUpload($_FILES['other_docs']);
                      $theater->otherDocSave($documents,$data["edit_id"]);
                  }
                  $theater->declarationSave($data["declaration"],$data["edit_id"]);
                  return $response->json(200,"success",['id'=>$data["edit_id"]]);
                }else{
                  return $response->json(400,"error",$errors);
                } 
             }
             
        }
    }


    public function theater_payment(Request $request,Response $response){
        $theater = new TheaterModel();
        $data = $request->getBody();
        if ($request->isPost()) {
            if ($theater->validation($data) && $theater->savePayment($data)) {
              return $response->json(200,"Your application has been submitted successfully",['redirect'=>'/']);
            }else{
              return $response->json(400,"error",$theater->errors);
            } 
        }
     }

}


?>