<?php

namespace app\src\core;
use app\src\core\Response;
use app\src\core\Database;
use app\src\core\Session;

class Application{
    public Router $router;
    public string $userClass;
     public static string $ROOT_DIR;
    public Request $request;
    public Response $response;
    public static Application $app;
    public Database $db;
    public Session $session;
    public $user;

    public $controller;

    public $view;

    public $status;



    function __construct($rootPath,$config){
         self::$ROOT_DIR = $rootPath;
         self::$app = $this;
         $this->request = new Request();
         $this->response = new Response();
         $this->router = new Router($this->request, $this->response);
         $this->db = new Database($config['db']);
         $this->userClass = $config['userClass'];
         $this->session = new Session();
         $this->view = new View;
         $this->status =  [
            "1" => "In Progress",
            "2" => "Clarification",
            "3" => "Rejected",
            "4" => "Approved",
        ];

         $userId = Application::$app->session->get('user');
        if ($userId) {
            $key = $this->userClass::primaryKey();
            $this->user = $this->userClass::findOne([$key => $userId]);
        }else{
            $this->user = null;
        }
    }
    
    public function login($user)
    {
        $this->user = $user;
        $className = get_class($user);
        $primaryKey = $className::primaryKey();
        $value = $user->{$primaryKey};
        Application::$app->session->set('user', $value);
        return true;
    }

    public function logout()
    {
        $this->user = null;
        self::$app->session->remove('user');
    }


    public static function isGuest()
    {
        return !self::$app->user;
    }
    function run(){
        try {
            echo $this->router->resolve();
        } catch (\Exception $e) {
            $this->response->setStatusCode($e->getCode());
            echo $this->router->renderView('_error', [
                'exception' => $e,
            ]);
        }
    }

}

?>