<?php
namespace app\src\core\helper\FileUpload;

use app\src\core\Application;

class FileUpload{

    public $error = false;
    function multiUpload($files){
            $target_dir = "docs/";
            $document = [];
            for ($i = 0; $i < count($files["name"]); $i++) {
                $original_filename = $files["name"][$i];
                $filename_without_spaces = str_replace(' ', '_', $original_filename);
                $current_timestamp = time(); 
                $file_name = $current_timestamp . '_' . $filename_without_spaces;
                $target_file = $target_dir . $file_name;
                if (move_uploaded_file($files["tmp_name"][$i], $target_file)) {
                    $document[] = $file_name;
                } 
            }
            return $document;
    }

    function upload($file){
        $target_dir = "docs/";
        $original_filename = $file["name"];
        $filename_without_spaces = str_replace(' ', '_', $original_filename);
        $current_timestamp = time(); 
        $file_name = $current_timestamp . '_' . $filename_without_spaces;
        $target_file = $target_dir . $file_name;
        if (move_uploaded_file($file["tmp_name"], $target_file)) {
            return $file_name;
        } 
        return $file_name;
    }

    function fileValidation($attributes){
        $maxFileSize = 2 * 1024 * 1024; // 2 MB
        $errors=[];
        foreach($attributes as $value) {
            if ($_FILES[$value]['size'] === 0 || !$_FILES[$value]['error'] == UPLOAD_ERR_OK) {
                $errors[$value][] = "File is required. Please upload the document.";
                $this->error = true;
            }else{
                if ($_FILES[$value]['size'] > $maxFileSize) {
                    $errors[$value][] = "File size should be less than 2MB";
                    $this->error = true;
                }
            }
        }
        return $errors;

    }
}


?>