<?php
namespace app\src\models;
use app\src\core\Application;
use Dompdf\Dompdf;

use app\src\core\helper\FileUpload\FileUpload;
use app\src\core\hepler\PDF\PDFGeneration;
use app\src\core\Model;
use PDO;

class HomeModel extends Model{
    
    public const END_USER = 2;
    public const POLICE = 1;
    public const LICENCE_WORKFLOW_ONE = 1;

    public const WORKFLOW_TWO = 2;
    public const WORKFLOW_THREE = 3;
    public const WORKFLOW_FOUR = 4;
    public const WORKFLOW_FIVE = 5;
    public const DESIG_ID_ONE = 1;
    public const DESIG_ID_TWO = 2;
    public const DESIG_ID_THREE = 3;
    public const DESIG_ID_FOUR = 4;
    public const DESIG_ID_FIVE = 5;
    public const DESIG_ID_SIX = 6;


    public const DESIG_ID_SEVEN = 7;

    public const DESIG_ID_EIGHT = 8;
    public const ONE = 1;
    public const WORKFLOW_SIX = 6;
    public function getUserDashbordInformation(){
        $user =  Application::$app->user;
        if($user && $user->user_type == self::END_USER ){
            return $this->getUserDashboardDetails($user);
        }

        if($user && $user->user_type == self::POLICE ){
            return $this->getPoliceDashboardDetails($user);
        }
    }

    public function getUserDashboardDetails($user){
        $all_status = [
            "applied" => true,
            "approved" => true,
            "rejected" => true,
            "renewal" => true,
            "fresh" => true,
            "inprogress" => true
        ];
        $records = $this->getUserCount($user);
        $data = $this->getUserData($user);
        $final_data = [
            "status" => $all_status,
            "count" => $records,
            "data" => $data
        ];
        return $final_data;
    }

    public function getUserCount($user){
        $statement = self::prepare("SELECT 
            SUM(CASE WHEN status = 1 THEN 1 ELSE 0 END) AS inprogress,
            SUM(1) AS applied,
            SUM(CASE WHEN status = 3 THEN 1 ELSE 0 END) AS rejected,
            SUM(CASE WHEN status = 4 THEN 1 ELSE 0 END) AS approved,
            SUM(CASE WHEN type = 2 THEN 1 ELSE 0 END) AS renewal,
            SUM(CASE WHEN type = 1 THEN 1 ELSE 0 END) AS fresh
            FROM  licence_details  WHERE  user_id = :user_id");
        $statement->bindParam(':user_id', $user->id);
        $statement->execute();
        $records = $statement->fetchAll(PDO::FETCH_ASSOC)[0];
        return $records;
    }

    public function getUserData($user){
        $recordsPerPage = 10;
        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $offset = ($page - 1) * $recordsPerPage;

        $stmt = SELF::prepare("SELECT ld.reference_number, pi.name, pi.date_of_birth, pi.gender, pi.aadhaar, ld.type, ld.id AS license_id, ld.created_at, ld.status FROM licence_details ld INNER JOIN personal_information pi ON pi.user_id = ld.user_id WHERE ld.user_id = :user_id LIMIT :limit OFFSET :offset");
        $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
        $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user->id, PDO::PARAM_INT);
        $stmt->execute();
        $records = $stmt->fetchAll(PDO::FETCH_ASSOC);

        $stmtTotal = self::prepare("SELECT COUNT(*) AS total FROM licence_details WHERE user_id =  :user_id ");
        $stmtTotal->bindParam(':user_id', $user->id, PDO::PARAM_INT);
        $stmtTotal->execute();
        $totalRecords = $stmtTotal->fetch(PDO::FETCH_ASSOC)['total'];
        
        $totalPages = ceil($totalRecords / $recordsPerPage);
        $response = [
            'records' => $records,
            'pagination' => [
                'totalPages' => $totalPages,
                'currentPage' => $page
            ]
        ];

        return $response;
    }

    public function getPoliceDashboardDetails($user){
        $status = $this->getStatusCount();
        $policeWorkflowAndZone = $this->getPoliceWorkFlowAndZoneDetails($user);
        $where = $this->setColumnameToGetLicense($policeWorkflowAndZone);
        $records = $this->getPoliceCount($policeWorkflowAndZone,$where);
        // $data = $this->getPoliceData($policeWorkflowAndZone,$where);
        $data = $this->getLicenseListBasedOnDesignation($policeWorkflowAndZone);
        $license_status = $this->getLicenseStatus($policeWorkflowAndZone['user_worflow_details'][0]['designation_id']);
        $license_department = [
            "1" => "License Section Assistant",
            "2"=> "License Section Superintendent",
            "3" => "License Section SAO"
        ];
        $jc_department = [
            "1" => "JCO Assistant",
            "2"=> "JCO Superintendent",
            "3" => "JCO SAO",
            "4" => "JC",
            "5" => "DC",
            "6" => "AC",
            "7" => "SHO",
            "8" => "AC",
            "9" => "DC",
            "10" => "JCO Assistant",
            "11"=> "JCO Superintendent",
            "12" => "JCO SAO",
            "13" => "JC",
            "14" => "AddlCoP"

        ];
        $proceeding_department = [
            "1" => "DC (Admin)",
            "2"=> "AddlCoP(Hq)",
            "3" => "COP"
        ];
        $final_data = [
            "status" => $status,
            "count" => $data['counts'],
            "data" => $data,
            "license_status" => $license_status,
            "license_department" => $license_department,
            "jc_department" => $jc_department,
            "proceeding_department" => $proceeding_department
        ];
        if($policeWorkflowAndZone['user_worflow_details'][0]['workflow'] == 1 && $policeWorkflowAndZone['user_worflow_details'][0]['designation_id'] == self::DESIG_ID_ONE){
            $new_data = $this->getPoliceData($policeWorkflowAndZone,$where,false);
            $final_data["new_data"] = $new_data ;
            $final_data["is_license_assitant"] = true ;
        }
        return $final_data;
         
    }

    public function getLicenseListBasedOnDesignation($policeWorkflowAndZone){
        $recordsPerPage = 10;
        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $offset = ($page - 1) * $recordsPerPage;

        $workflow = $policeWorkflowAndZone['user_worflow_details'][0]['workflow'];
        $designationId = $policeWorkflowAndZone['user_worflow_details'][0]['designation_id'];
    
        $flags = [];
        foreach($policeWorkflowAndZone['user_worflow_details'] as $workflowDetails){
           $flags[] = $workflowDetails['flag'];
        }
        
        $isProceed = true;
        if($workflow == 1){
            $stmt = self::prepare("SELECT 
                    (CASE WHEN license_department IN (".implode(',', $flags).") AND zone_id = :zone_id THEN 1 ELSE 0 END) AS action, 
                    ld.reference_number, 
                    pi.name, 
                    ld.doc_verified, 
                    ld.is_memo_created, 
                    ld.is_report_created, 
                    ld.license_department,
                    ld.lando,
                    ld.proceeding,
                    pi.date_of_birth, 
                    pi.gender, 
                    pi.aadhaar, 
                    ld.type, 
                    ld.id AS license_id, 
                    ld.created_at, 
                    ld.status 
                FROM 
                    licence_details ld 
                INNER JOIN 
                    personal_information pi ON pi.user_id = ld.user_id 
                WHERE 
                    zone_id = :zone_id 
                    AND is_proceed = :isProceed 
                LIMIT 
                    :limit OFFSET :offset
            ");
            $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
            $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
            $stmt->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $stmt->bindParam(':isProceed', $isProceed, PDO::PARAM_INT);
            $stmt->execute();
            $records = $stmt->fetchAll(PDO::FETCH_ASSOC);
          
            $stmtTotal = self::prepare("SELECT COUNT(*) AS total FROM licence_details  WHERE  zone_id = :zone_id AND is_proceed = :isProceed AND license_department IN (".implode(',', $flags).")");
            $stmtTotal->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $stmtTotal->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $stmtTotal->execute();
            $totalRecords = $stmtTotal->fetch(PDO::FETCH_ASSOC)['total'];

           
            $statement_count = self::prepare("SELECT 
                    SUM(CASE WHEN status = 1 THEN 1 ELSE 0 END) AS inprogress,
                    SUM(CASE WHEN type = 2 THEN 1 ELSE 0 END) AS renewal,
                    SUM(CASE WHEN type = 1 THEN 1 ELSE 0 END) AS fresh
                    FROM  licence_details  WHERE zone_id = :zone_id AND is_proceed = :isProceed AND license_department IN (".implode(',', $flags).")");
            $statement_count->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $statement_count->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $statement_count->execute();
            $counts = $statement_count->fetch(PDO::FETCH_ASSOC);
           
                
        }elseif($workflow == 2){
            $jc_license = [4,5,6,7,11];
            if(in_array($designationId,$jc_license)){
                $stmt = self::prepare("SELECT 
                    (CASE WHEN lando IN (".implode(',', $flags).") AND zone_id = :zone_id THEN 1 ELSE 0 END) AS action, 
                    ld.reference_number, 
                    pi.name, 
                    ld.doc_verified, 
                    ld.is_memo_created, 
                    ld.is_report_created, 
                    ld.license_department,
                    ld.lando,
                    ld.proceeding,
                    pi.date_of_birth, 
                    pi.gender, 
                    pi.aadhaar, 
                    ld.type, 
                    ld.id AS license_id, 
                    ld.created_at, 
                    ld.status 
                        FROM 
                            licence_details ld 
                        INNER JOIN 
                            personal_information pi ON pi.user_id = ld.user_id 
                        WHERE 
                            zone_id = :zone_id 
                            AND is_proceed = :isProceed 
                        LIMIT 
                            :limit OFFSET :offset
                    ");
                    $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
                    $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
                    $stmt->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
                    $stmt->bindParam(':isProceed', $isProceed, PDO::PARAM_INT);
                    $stmt->execute();
                    $records = $stmt->fetchAll(PDO::FETCH_ASSOC);
            }else{
                $stmt = self::prepare("SELECT 
                 (CASE WHEN lando IN (".implode(',', $flags).") AND zone_id = :zone_id THEN 1 ELSE 0 END) AS action, 
                ld.reference_number, 
                pi.name, 
                ld.doc_verified, 
                ld.is_memo_created, 
                ld.is_report_created, 
                pi.date_of_birth, 
                pi.gender, 
                pi.aadhaar, 
                ld.type, 
                ld.id AS license_id, 
                ld.created_at, 
                ld.status ,
                ld.proceeding
                FROM 
                    licence_details ld 
                INNER JOIN 
                    personal_information pi ON pi.user_id = ld.user_id 
                WHERE 
                    zone_id = :zone_id AND
                    is_proceed = :isProceed AND
                    lando IN (".implode(',', $flags).")
                LIMIT 
                    :limit OFFSET :offset
                ");
                $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
                $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
                $stmt->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
                $stmt->bindParam(':isProceed', $isProceed, PDO::PARAM_INT);
                $stmt->execute();
                $records = $stmt->fetchAll(PDO::FETCH_ASSOC);
            }

            $stmtTotal = self::prepare("SELECT COUNT(*) AS total FROM licence_details  WHERE  zone_id = :zone_id AND is_proceed = :isProceed AND license_department IN (".implode(',', $flags).")");
            $stmtTotal->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $stmtTotal->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $stmtTotal->execute();
            $totalRecords = $stmtTotal->fetch(PDO::FETCH_ASSOC)['total'];

            $statement_count = self::prepare("SELECT 
                    SUM(CASE WHEN status = 1 THEN 1 ELSE 0 END) AS inprogress,
                    SUM(CASE WHEN type = 2 THEN 1 ELSE 0 END) AS renewal,
                    SUM(CASE WHEN type = 1 THEN 1 ELSE 0 END) AS fresh
                    FROM  licence_details  WHERE zone_id = :zone_id AND is_proceed = :isProceed AND lando IN (".implode(',', $flags).")");
            $statement_count->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $statement_count->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $statement_count->execute();
            $counts = $statement_count->fetch(PDO::FETCH_ASSOC);
        }elseif($workflow == 6){
               $stmt = self::prepare("SELECT 
                 (CASE WHEN proceeding IN (".implode(',', $flags).") AND zone_id = :zone_id THEN 1 ELSE 0 END) AS action, 
                ld.reference_number, 
                pi.name, 
                ld.doc_verified, 
                ld.is_memo_created, 
                ld.is_report_created, 
                pi.date_of_birth, 
                ld.license_department,
                ld.lando,
                pi.gender, 
                pi.aadhaar, 
                ld.type, 
                ld.id AS license_id, 
                ld.created_at, 
                ld.status ,
                ld.proceeding
                FROM 
                    licence_details ld 
                INNER JOIN 
                    personal_information pi ON pi.user_id = ld.user_id 
                WHERE 
                    zone_id = :zone_id AND
                    is_proceed = :isProceed  
                LIMIT 
                    :limit OFFSET :offset
                ");

                $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
                $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
                $stmt->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
                $stmt->bindParam(':isProceed', $isProceed, PDO::PARAM_INT);
                $stmt->execute();
                $records = $stmt->fetchAll(PDO::FETCH_ASSOC);
           
            $stmtTotal = self::prepare("SELECT COUNT(*) AS total FROM licence_details  WHERE  zone_id = :zone_id AND is_proceed = :isProceed AND proceeding IN (".implode(',', $flags).")");
            $stmtTotal->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $stmtTotal->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $stmtTotal->execute();
            $totalRecords = $stmtTotal->fetch(PDO::FETCH_ASSOC)['total'];

        
            $statement_count = self::prepare("SELECT 
                    SUM(CASE WHEN status = 1 THEN 1 ELSE 0 END) AS inprogress,
                    SUM(CASE WHEN type = 2 THEN 1 ELSE 0 END) AS renewal,
                    SUM(CASE WHEN type = 1 THEN 1 ELSE 0 END) AS fresh
                    FROM  licence_details  WHERE zone_id = :zone_id AND is_proceed = :isProceed AND proceeding IN (".implode(',', $flags).")");
            $statement_count->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
            $statement_count->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
            $statement_count->execute();
            $counts = $statement_count->fetch(PDO::FETCH_ASSOC);
        }
        
        
        $totalPages = ceil($totalRecords / $recordsPerPage);
        $response = [
            'records' => $records,
             'counts' => $counts,
            'pagination' => [
                'totalPages' => $totalPages,
                'currentPage' => $page
            ]
        ];

        return $response;
    }

    public function getStatusCount(){
        return  [
            "renewal" => true,
            "fresh" => true,
            "inprogress" => true
        ];
    }

    public function setColumnameToGetLicense($policeWorkflowAndZone){
        if($policeWorkflowAndZone['user_worflow_details'][0]['workflow'] == self::LICENCE_WORKFLOW_ONE ){
            $whereCount = "license_department = :flag AND zone_id = :zone_id";
            $whereData = "ld.license_department = :flag AND ld.zone_id = :zone_id";
        }
        if($policeWorkflowAndZone['user_worflow_details'][0]['workflow'] == self::WORKFLOW_TWO ){
            $whereCount = "lando = :flag AND zone_id = :zone_id";
            $whereData = "ld.lando = :flag AND ld.zone_id = :zone_id";
        }

        if($policeWorkflowAndZone['user_worflow_details'][0]['workflow'] == self::WORKFLOW_SIX ){
            $whereCount = "proceeding = :flag AND zone_id = :zone_id";
            $whereData = "ld.proceeding = :flag AND ld.zone_id = :zone_id";
        }
        $where = [
            "count" => $whereCount,
            'workflow' =>$whereData,
        ];

        return $where;
    }

    public function getPoliceCount($policeWorkflowAndZone,$query){
        $statement = self::prepare("SELECT 
            SUM(CASE WHEN status = 1 THEN 1 ELSE 0 END) AS inprogress,
            SUM(CASE WHEN type = 2 THEN 1 ELSE 0 END) AS renewal,
            SUM(CASE WHEN type = 1 THEN 1 ELSE 0 END) AS fresh
            FROM  licence_details  WHERE ".$query['count']);
        $statement->bindParam(':flag', $policeWorkflowAndZone["user_worflow_details"][0]['flag'],PDO::PARAM_INT);
        $statement->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'],PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(PDO::FETCH_ASSOC)[0];
        return $records;    
    }

    public function getPoliceWorkFlowAndZoneDetails($user){
        $user_role = $this->getUserDesignation($user->id);
        $workflow_statement = self::prepare("SELECT * FROM  m_gcp_work_flow  WHERE  designation_id = :designation_id");
        $workflow_statement->bindParam(':designation_id', $user_role["designation_id"]);
        $workflow_statement->execute();
        $user_worflow_details = $workflow_statement->fetchAll(PDO::FETCH_ASSOC);
        $user_details = [
            "user_worflow_details" => $user_worflow_details,
            "user_role" => $user_role
        ];
        return $user_details;   
    }

    public function getUserDesignation($id){
        $statement = self::prepare("SELECT * FROM  user_role_mapping  WHERE  user_id = :user_id");
        $statement->bindParam(':user_id', $id,PDO::PARAM_INT);
        $statement->execute();
        $user_role = $statement->fetchAll(PDO::FETCH_ASSOC)[0];
        return $user_role;
    }

    public function getPoliceData($policeWorkflowAndZone,$query,$isProceed = true){
        $recordsPerPage = 10;
        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $offset = ($page - 1) * $recordsPerPage;
        $isQuery = 0;
        $stmt = SELF::prepare("SELECT ld.reference_number, pi.name,ld.doc_verified,ld.is_memo_created,ld.is_report_created, pi.date_of_birth, pi.gender, pi.aadhaar, ld.type, ld.id AS license_id, ld.created_at, ld.status FROM licence_details ld INNER JOIN personal_information pi ON pi.user_id = ld.user_id WHERE ".$query['workflow']." AND is_proceed = :isProceed AND is_query = :isQuery LIMIT :limit OFFSET :offset");
        $stmt->bindParam(':limit', $recordsPerPage, PDO::PARAM_INT);
        $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
        $stmt->bindParam(':flag', $policeWorkflowAndZone["user_worflow_details"][0]['flag'],PDO::PARAM_INT);
        $stmt->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'],PDO::PARAM_INT);
        $stmt->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
        $stmt->bindParam(':isQuery', $isQuery,PDO::PARAM_INT);
        $stmt->execute();
        $records = $stmt->fetchAll(PDO::FETCH_ASSOC);

        $stmtTotal = self::prepare("SELECT COUNT(*) AS total FROM licence_details ld WHERE ".$query['workflow']." AND is_proceed = :isProceed");
        $stmtTotal->bindParam(':flag', $policeWorkflowAndZone["user_worflow_details"][0]['flag'], PDO::PARAM_INT);
        $stmtTotal->bindParam(':zone_id', $policeWorkflowAndZone["user_role"]['zone_id'], PDO::PARAM_INT);
        $stmtTotal->bindParam(':isProceed', $isProceed,PDO::PARAM_INT);
        $stmtTotal->execute();
        $totalRecords = $stmtTotal->fetch(PDO::FETCH_ASSOC)['total'];
        
        $totalPages = ceil($totalRecords / $recordsPerPage);
        $response = [
            'records' => $records,
            'pagination' => [
                'totalPages' => $totalPages,
                'currentPage' => $page
            ]
        ];

        return $response;
    }


    public function getNewApplicationDetails($id){
        $stmt = SELF::prepare("SELECT ld.reference_number, pi.name,ld.address,ld.police_station,pi.img, ld.id AS license_id, ld.created_at, ld.status FROM licence_details ld INNER JOIN personal_information pi ON pi.user_id = ld.user_id WHERE ld.id = :id");
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $data= $stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        return $data;
    }

    public function proceedLicense($data){
        $active = 1;
        if($data['police_station']){
            $stmt = SELF::prepare("UPDATE licence_details SET police_station = :police_station , is_proceed=:is_proceed WHERE id= :id ");
            $stmt->bindParam(':police_station', $data['police_station'], PDO::PARAM_INT);
        }else{
            $stmt = SELF::prepare("UPDATE licence_details SET is_proceed=:is_proceed WHERE id= :id ");
        }
        $stmt->bindParam(':is_proceed', $active, PDO::PARAM_INT);
        $stmt->bindParam(':id', $data['license_id'], PDO::PARAM_INT);
        $stmt->execute();
       return true;
    }

    public function getApplicationDetails($id){
        $user_id =  Application::$app->user ? Application::$app->user->id : "0";
        $stmt = SELF::prepare("SELECT pi.id as personal_id ,pi.*,ld.* FROM licence_details ld INNER JOIN personal_information pi ON pi.user_id = ld.user_id WHERE ld.id = :id");
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $lisenseStatus_and_person= $stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        

        $theater_stmt = SELF::prepare("SELECT * FROM theatre_information ti INNER JOIN theatre_docs td ON td.theatre_information_id = ti.id WHERE ti.license_details_id = :id");
        $theater_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $theater_stmt->execute();
        $theater_data= $theater_stmt->fetchAll(PDO::FETCH_ASSOC)[0];

        
        $theater_other_doc_stmt = SELF::prepare("SELECT * FROM other_user_docs WHERE theater_id = :id");
        $theater_other_doc_stmt->bindParam(':id', $theater_data['id'], PDO::PARAM_INT);
        $theater_other_doc_stmt->execute();
        $theater_other_docs = $theater_other_doc_stmt->fetchAll(PDO::FETCH_ASSOC);
       

        $qry_stmt = SELF::prepare("SELECT lq.query,lq.doc,d.designation FROM licence_query lq INNER JOIN m_designation d on d.id = lq.designation_id WHERE lq.license_details_id = :id");
        $qry_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $qry_stmt->execute();
        $qry_list = $qry_stmt->fetchAll(PDO::FETCH_ASSOC);


        $masterObject = new MasterTableModel(); 
        $getPoliceDesignations = $masterObject->getPoliceDesignations();
        $lisenseStatus_and_person['birth_country_id']  = $masterObject->getCountryName($lisenseStatus_and_person['birth_country_id']);
        $lisenseStatus_and_person['birth_state_id']  = $masterObject->getStateName($lisenseStatus_and_person['birth_state_id']);
        $lisenseStatus_and_person['birth_city_id']  = $masterObject->getCityName($lisenseStatus_and_person['birth_city_id']);
        $theater_data['police_station'] = $masterObject->getPoliceStationName($theater_data['police_station']);
        $queryEnable = $this->queryEnable($id);
        $isForward = $this->isForward($id);
        $lisenseStatus_and_person['zone_id'] = $masterObject->getZoneName($lisenseStatus_and_person['zone_id']);
        $memo_details = $this->getMemoDetails($getPoliceDesignations[0]['id'],$id);
        $checklist_details = $this->getChecklistDetails($getPoliceDesignations[0]['id'],$id) ? $this->getChecklistDetails($getPoliceDesignations[0]['id'],$id)[0] : [];
        $document_details = $this->getOfficersDocs($getPoliceDesignations[0]['id'],$id);
        $isMemoOption = $this->isMemoOption($id);
        $add_or_update_enable = $this->checkAddOrUpdateBtn($getPoliceDesignations[0]['id']);
        $is_approval_btn_enable = $this->checkApprovalButtonEnable($getPoliceDesignations[0]['id']);
        $remarks = $this->getRemarks($id);
        $reverseRemarks = $this->getReverseRemarks($id);
        $isNotes = $this->isNotes($id);
        // $notes = $this->getNotes($id);
        $isReport = $this->isReport($getPoliceDesignations[0]['id'],$id);
        $report = $this->getReport($getPoliceDesignations[0]['id'],$id);
        $inReportNotesOnly = $this->inReportNotesOnly($getPoliceDesignations[0]['id']);
        $is_access = $this->isAccess($getPoliceDesignations[0]['id'],$id);
        $isLicenseDone = $this->isLicenseDone($id);
        // $isReverseRemark = $this->$isReverseRemark($getPoliceDesignations[0]['id'],$id);
        $data = [
            "theater_data" =>$theater_data,
            "lisenseStatus_and_person" => $lisenseStatus_and_person,
            "license_cmt" => $remarks,
            "getPoliceDesignations" => $getPoliceDesignations,
            "qry_list" => $qry_list,
            "queryEnable"=>$queryEnable,
            "isForward" => $isForward,
            "memo_details"=>$memo_details,
            "checklist_details" => $checklist_details,
            'document_details' => $document_details,
            'isMemoOption' => $isMemoOption,
            "isReport" => $isReport,
            "userId" => $user_id,
            "add_or_update_enable" => $add_or_update_enable,
            "is_approval_btn_enable" => $is_approval_btn_enable,
            "isNotes" => $isNotes,
            // "notes" => $notes,
            "is_access" => $is_access,
            "report" => $report,
            "inReportNotesOnly" =>$inReportNotesOnly,
            "isLicenseDone" => $isLicenseDone,
            "theater_other_docs" => $theater_other_docs,
            "isReverseRemark" => $isReport,
            "reverseRemarks" => $reverseRemarks
        ];
        return $data;
    }

    public function isAccess($designation_id,$license_id){
        $user =  Application::$app->user;
        $policeWorkflowAndZone = $this->getPoliceWorkFlowAndZoneDetails($user);
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$license_id, PDO::PARAM_INT);
        $license_stmt->execute();
        $license_status= $license_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        $workFlow = $policeWorkflowAndZone['user_worflow_details'][0]['workflow'];
        $is_access = false;
        if($workFlow == self::LICENCE_WORKFLOW_ONE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
               if($value['flag'] == $license_status['license_department']){
                 $is_access = true;
               }
            } 
        }elseif($workFlow == self::WORKFLOW_TWO){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['lando']){
                    $is_access = true;
                }
             }
        }elseif($workFlow == self::WORKFLOW_THREE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['traffic']){
                    $is_access = true;
                }
             }
        }elseif($workFlow == self::WORKFLOW_FOUR){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['IS_department']){
                    $is_access = true;
                }
             }  
        }elseif($workFlow == self::WORKFLOW_FIVE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['ccp_department']){
                    $is_access = true;
                }
             }
        }else{
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['proceeding']){
                    $is_access = true;
                }
             }
        }
        return $is_access;
    }

    public function inReportNotesOnly($designation_id){
        $designation = [1,2,3,4,5,6];
        if(in_array($designation_id,$designation)){
           return true;
        }else{
            return false;
        }
    }

    public function getLicenseStatus($designation_id){
        $designation = [1,2,3,4,5,6,7,11,12,13,14];
        if(in_array($designation_id,$designation)){
           return true;
        }else{
            return false;
        }
    }

    public function getReport($designation_id,$id){
        $stmt = SELF::prepare("SELECT * FROM license_report WHERE license_details_id = :license_details_id AND designation_id= :designation_id");
        $stmt->bindParam(':license_details_id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':designation_id', $designation_id, PDO::PARAM_INT);
        $stmt->execute(); 
        $report_details = $stmt->fetch(PDO::FETCH_ASSOC); 
        if (!$report_details) {
            $report_details = [];
        }
        return $report_details;
    }

    public function isReport($designation_id,$id){
        $stmt = SELF::prepare("SELECT * FROM licence_details WHERE id = :id");
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $license_details= $stmt->fetch(PDO::FETCH_ASSOC);

        $workflow_stmt = SELF::prepare("SELECT * FROM m_gcp_work_flow WHERE designation_id = :designation_id");
        $workflow_stmt->bindParam(':designation_id', $designation_id, PDO::PARAM_INT);
        $workflow_stmt->execute();
        $workflow_details= $workflow_stmt->fetchAll(PDO::FETCH_ASSOC);
        $is_enable = false;
        foreach($workflow_details as $key => $value) {
            if($value['workflow'] == 1 && $license_details['lando_done'] == 1){
                $is_enable = true;
            }
            if($value['workflow'] == 2 &&  $license_details['lando'] >= 7){
                $is_enable = true;
            }
            if($value['workflow'] == 3 &&  $value['flag'] == $license_details['traffic']){
                $is_enable = true;
            }
            if($value['workflow'] == 4 &&  $value['flag'] == $license_details['IS_department']){
                $is_enable = true;
            }
            if($value['workflow'] == 5 &&  $value['flag'] == $license_details['ccp_department']){
                $is_enable = true;
            }
            if($value['workflow'] == 6 &&  $value['flag'] == $license_details['proceeding']){
                $is_enable = true;
            }
        }
        return $is_enable;
    }

    public function getRemarks($id){
        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
        $license_department = [1,2,3];
        $jc_department = [3,4,5,6,7];
        $jc_exclude_license = [7,8,9,10,11];
        $proceeding = [12,13,14];
        if (in_array($userDesignation['designation_id'], $license_department)) {
            return $this->getRemarksBasedOnDesAndDep($license_department,$id);
        }
        if (in_array($userDesignation['designation_id'], $jc_department)) {
            return $this->getRemarksBasedOnDesAndDep($jc_department,$id);
        }
        if (in_array($userDesignation['designation_id'], $jc_exclude_license)) {
            return $this->getRemarksBasedOnDesAndDep($jc_exclude_license,$id);
        }
        if (in_array($userDesignation['designation_id'], $proceeding)) {
            return $this->getRemarksBasedOnDesAndDep($proceeding,$id);
        }
        return [];
    }

    public function getReverseRemarks($license_id){
        $cmt_stmt = self::prepare("SELECT lc.comments, d.designation 
        FROM licence_reverse_remarks lc 
        INNER JOIN m_designation d ON d.id = lc.designation_id 
        WHERE lc.license_details_id = :id");
        $cmt_stmt->bindParam(":id", $license_id, PDO::PARAM_INT); 
        $cmt_stmt->execute();
        $remarks_data = $cmt_stmt->fetchAll(PDO::FETCH_ASSOC);
        return $remarks_data;
    }

    public function getNotes($license_id){
        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
        $license_department = [1,2,3];
        $jc_department = [3,4,5,6,7];
        $jc_exclude_license = [8,9,10];
        if (in_array($userDesignation['designation_id'], $license_department)) {
            $cmt_stmt = self::prepare("SELECT ln.notes, d.designation 
            FROM license_notes ln
            INNER JOIN m_designation d ON d.id = ln.designation_id 
            WHERE ln.designation_id IN (".implode(',', $license_department).") 
            AND ln.license_details_id = :id");
            $cmt_stmt->bindParam(":id", $license_id, PDO::PARAM_INT); 
            $cmt_stmt->execute();
            $remarks_data = $cmt_stmt->fetchAll(PDO::FETCH_ASSOC);
            return $remarks_data;
        }
        if (in_array($userDesignation['designation_id'], $jc_department)) {
            $cmt_stmt = self::prepare("SELECT ln.notes, d.designation 
            FROM license_notes ln
            INNER JOIN m_designation d ON d.id = ln.designation_id 
            WHERE ln.designation_id IN (".implode(',', $jc_department).") 
            AND ln.license_details_id = :id");
            $cmt_stmt->bindParam(":id", $license_id, PDO::PARAM_INT); 
            $cmt_stmt->execute();
            $remarks_data = $cmt_stmt->fetchAll(PDO::FETCH_ASSOC);
            return $remarks_data;
        }
        return [];
    }

    public function getRemarksBasedOnDesAndDep($role,$license_id){
        $cmt_stmt = self::prepare("SELECT lc.comments, d.designation 
        FROM licence_comments lc 
        INNER JOIN m_designation d ON d.id = lc.designation_id 
        WHERE lc.designation_id IN (".implode(',', $role).") 
        AND lc.license_details_id = :id");
        $cmt_stmt->bindParam(":id", $license_id, PDO::PARAM_INT); 
        $cmt_stmt->execute();
        $remarks_data = $cmt_stmt->fetchAll(PDO::FETCH_ASSOC);
        return $remarks_data;
    }

    public function checkAddOrUpdateBtn($designation_id){
        if($designation_id == self::DESIG_ID_ONE || $designation_id == self::DESIG_ID_TWO || $designation_id == self::DESIG_ID_THREE || $designation_id == self::DESIG_ID_FOUR || $designation_id == self::DESIG_ID_FIVE || $designation_id == self::DESIG_ID_SIX){
            return true;
        }else{
            return false;
        }
    }

    public function isNotes($license_id){
        $id =  Application::$app->user ? Application::$app->user->id : "";
        $role = $this->getUserDesignation($id);
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$license_id, PDO::PARAM_INT);
        $license_stmt->execute();
        $license_status= $license_stmt->fetch(PDO::FETCH_ASSOC);
        $license = [1,2,3];
        $jc_office = [4,5,6,7];
        if(in_array($role['designation_id'] ,$license) && $license_status["lando_done"] != 1){
            return true;
        }elseif(in_array($role['designation_id'] ,$jc_office) && $license_status["lando"] <= 7){
            return true;
        }
        else{
            return false;
        }
    }

    public function isLicenseDone($license_id){
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$license_id, PDO::PARAM_INT);
        $license_stmt->execute();
        $license_status= $license_stmt->fetch(PDO::FETCH_ASSOC);
        if($license_status['proceedings_done'] == 1){
            return true;
        }
        return false;;
    }

    public function checkApprovalButtonEnable($designation_id){
        if($designation_id == self::DESIG_ID_THREE || $designation_id == self::DESIG_ID_SIX || $designation_id == self::DESIG_ID_SEVEN){
            return true;
        }else{
            return false;
        }
    }

    public function isMemoOption($license_id){
        $id =  Application::$app->user ? Application::$app->user->id : "";
        $role = $this->getUserDesignation($id);
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$license_id, PDO::PARAM_INT);
        $license_stmt->execute();
        $license_status= $license_stmt->fetch(PDO::FETCH_ASSOC);
        $license = [1,2,3];
        $jc_office = [4,5,6,7];
        if(in_array($role['designation_id'] ,$license) && $license_status["lando_done"] != 1){
            return true;
        }elseif(in_array($role['designation_id'] ,$jc_office) && $license_status["lando"] <= 7){
            return true;
        }
        else{
            return false;
        }
    }

    public function getMemoDetails($designation_id,$license_details_id){
        $dep_stmt = SELF::prepare("SELECT * FROM m_designation WHERE id = :id");
        $dep_stmt->bindParam(':id', $designation_id, PDO::PARAM_INT);
        $dep_stmt->execute();
        $department_details = $dep_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        $memo_stmt = self::prepare("SELECT * FROM memo m  WHERE m.license_details_id = :id AND m.department_id = :department_id ORDER BY m.designation_id DESC");
        $memo_stmt->bindParam(':id', $license_details_id, PDO::PARAM_INT);
        $memo_stmt->bindParam(':department_id', $department_details['department_id'], PDO::PARAM_INT);
        $memo_stmt->execute();
        $memo_details = $memo_stmt->fetchAll(PDO::FETCH_ASSOC);
        if(!empty($memo_details)){
            $memo_other_stmt = self::prepare("SELECT * FROM memo_details  WHERE memo_id = :memo_id ");
            $memo_other_stmt->bindParam(':memo_id', $memo_details[0]['id'], PDO::PARAM_INT);
            $memo_other_stmt->execute();
            $memo_other_details = $memo_other_stmt->fetchAll(PDO::FETCH_ASSOC);
            $memo_details[0]['memo_other_details'] =  $memo_other_details;
        }
        return $memo_details;
    }

    public function getOfficersDocs($designation_id,$license_details_id){
        $license_department = [1,2,3];
        $jc_department = [3,4,5,6,7];
        $jc_exclude_license = [7,8,9,10,11];
        $proceeding = [12,13,14];
        if (in_array($designation_id, $license_department)) {
            return $this->getDocsBasedOnDesAndDep($license_department,$license_details_id);
        }
        if (in_array($designation_id, $jc_department)) {
            return $this->getDocsBasedOnDesAndDep($jc_department,$license_details_id);
        }
        if (in_array($designation_id, $jc_exclude_license)) {
            return $this->getDocsBasedOnDesAndDep($jc_exclude_license,$license_details_id);
        }
        if (in_array($designation_id, $proceeding)) {
            return $this->getDocsBasedOnDesAndDep($proceeding,$license_details_id);
        }
        return [];

    }

    public function getDocsBasedOnDesAndDep($role,$license_details_id){
        $doc_stmt = SELF::prepare("SELECT od.doc,d.designation,od.user_id,od.id FROM officers_docs od INNER JOIN m_designation d on d.id = od.designation_id WHERE od.designation_id IN (".implode(',', $role).") AND od.license_details_id = :id");
        $doc_stmt->bindParam(':id', $license_details_id, PDO::PARAM_INT);
        $doc_stmt->execute();
        $doc_details = $doc_stmt->fetchAll(PDO::FETCH_ASSOC);
        return $doc_details;
    }

    public function getChecklistDetails($getPoliceDesignations_id,$license_details_id){
        $checklist_stmt = SELF::prepare("SELECT * FROM officer_theater_checklist otc WHERE otc.license_details_id = :id AND designation_id=:designation_id");
        $checklist_stmt->bindParam(':id', $license_details_id, PDO::PARAM_INT);
        $checklist_stmt->bindParam(':designation_id', $getPoliceDesignations_id, PDO::PARAM_INT);
        $checklist_stmt->execute();
        $checklist_details = $checklist_stmt->fetchAll(PDO::FETCH_ASSOC);
        return $checklist_details;
    }

    public function queryEnable($license_id){
        $id =  Application::$app->user ? Application::$app->user->id : "";
        $role = $this->getUserDesignation($id);
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$license_id, PDO::PARAM_INT);
        $license_stmt->execute();
        $license_status= $license_stmt->fetch(PDO::FETCH_ASSOC);
        $license = [1,3];
        $jc_office = [7];
        if(in_array($role['designation_id'] ,$license) && $license_status["lando_done"] != 1){
            return true;
        }elseif(in_array($role['designation_id'] ,$jc_office) && $license_status["lando"] >= 7){
            return true;
        }
        else{
            return false;
        }
    }

    function isForward($license_id){
        $id =  Application::$app->user ? Application::$app->user->id : "";
        $role = $this->getUserDesignation($id);
        $status = false;
        if($role['designation_id'] == self::DESIG_ID_ONE || $role['designation_id'] == self::DESIG_ID_TWO || $role['designation_id'] == self::DESIG_ID_THREE || $role['designation_id'] == self::DESIG_ID_FOUR || $role['designation_id'] == self::DESIG_ID_FIVE || $role['designation_id'] == self::DESIG_ID_SIX || $role['designation_id'] == self::DESIG_ID_SEVEN){
            if($role['designation_id'] == self::DESIG_ID_SEVEN){
                $stmt = SELF::prepare("SELECT * FROM memo m WHERE m.license_details_id = :license_details_id ORDER BY m.designation_id DESC LIMIT 1 ");
            }else{
                $stmt = SELF::prepare("SELECT * FROM memo m WHERE m.license_details_id = :license_details_id AND m.user_id = :user_id AND m.designation_id =:desId");
                $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
                $stmt->bindParam(':desId', $role['designation_id'], PDO::PARAM_INT);
            }
            $stmt->bindParam(':license_details_id', $license_id, PDO::PARAM_INT);
            $stmt->execute();
            $data = $stmt->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($data)){
                if($role['designation_id'] == self::DESIG_ID_THREE){
                    if($data[0]['license_sho_approval'] == 1){
                        $status=true;
                    }
                }elseif($role['designation_id'] == self::DESIG_ID_SIX){
                    if($data[0]['jc_sho_approval'] == 1){
                        $status=true;
                    }
                }elseif($role['designation_id'] == self::DESIG_ID_SEVEN){
                    if($data[0]['jc_approval'] == 1){
                        $status=true;
                    }
                }else{
                    $status=true;
                }
            }
        }
        else{
            $status = true;
        }

        return $status;
    }

    public function getUserApplicationDetails($id){
       
        $stmt = SELF::prepare("SELECT pi.id as personal_id ,pi.*,ld.* FROM licence_details ld INNER JOIN personal_information pi 
         ON pi.user_id = ld.user_id WHERE ld.id = :id");
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $lisenseStatus_and_person= $stmt->fetch(PDO::FETCH_ASSOC);

        

        $theater_stmt = SELF::prepare("SELECT td.id as theatre_docs_id , ti.id as theater_id,ti.*,td.* FROM theatre_information ti INNER JOIN 
         theatre_docs td ON td.theatre_information_id = ti.id WHERE ti.license_details_id = :id");
        $theater_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $theater_stmt->execute();
        $theater_data = $theater_stmt->fetch(PDO::FETCH_ASSOC);
      

        $theater_other_doc_stmt = SELF::prepare("SELECT * FROM other_user_docs WHERE theater_id = :id");
        $theater_other_doc_stmt->bindParam(':id', $theater_data['id'], PDO::PARAM_INT);
        $theater_other_doc_stmt->execute();
        $theater_other_docs = $theater_other_doc_stmt->fetchAll(PDO::FETCH_ASSOC);
        
       
        $isResolved = 0;
        $qry_stmt = SELF::prepare("SELECT lq.query,lq.doc,d.designation FROM licence_query lq INNER JOIN m_designation d on d.id = lq.designation_id WHERE lq.license_details_id = :id AND is_resolved=:isResolved");
        $qry_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $qry_stmt->bindParam(':isResolved', $isResolved, PDO::PARAM_INT);
        
        $qry_stmt->execute();
        $qry_list = $qry_stmt->fetchAll(PDO::FETCH_ASSOC);


        $masterObject = new MasterTableModel(); 
        $getPoliceDesignations = $masterObject->getPoliceDesignations();
        $lisenseStatus_and_person['birth_country_id']  = $masterObject->getCountryName($lisenseStatus_and_person['birth_country_id']);
        $lisenseStatus_and_person['birth_state_id']  = $masterObject->getStateName($lisenseStatus_and_person['birth_state_id']);
        $lisenseStatus_and_person['birth_city_id']  = $masterObject->getCityName($lisenseStatus_and_person['birth_city_id']);
        $theater_data['police_station_id']  = $theater_data['police_station'] ;
        $theater_data['police_station'] = $masterObject->getPoliceStationName($theater_data['police_station']);
      
        $data = [
            "theater_data" =>$theater_data,
            "lisenseStatus_and_person" => $lisenseStatus_and_person,
            "getPoliceDesignations" => $getPoliceDesignations,
            "qry_list" => $qry_list,
            "theater_other_docs" => $theater_other_docs
        ];
        return $data;
    }

    public function addRemarks($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        foreach($data["remarks"] as  $value){
            $stmt = SELF::prepare("INSERT INTO  licence_comments (license_details_id,comments,user_id,designation_id) values (:license_details_id,:comments,:user_id,:designation_id) ");
            $stmt->bindParam(':license_details_id', $data['license_id']);
            $stmt->bindParam(':comments', $value);
            $stmt->bindParam(':user_id', $id);
            $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
            $stmt->execute();
        }
        return true;
    }

    public function addQuery($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $doc ="";
        $cc_to = $data['query_cc'] ? $data['query_cc'] : "";
        if (!$_FILES["queryFile"]['size'] === 0 || $_FILES["queryFile"]['error'] == UPLOAD_ERR_OK) {
            $fileUpload = new FileUpload();
            $doc = $fileUpload->upload($_FILES["queryFile"]);
        }
        $stmt = SELF::prepare("INSERT INTO  licence_query (license_details_id,query,doc,user_id,designation_id,cc_to) values (:license_details_id,:query,:doc,:user_id,:designation_id,:cc_to) ");
        $stmt->bindParam(':license_details_id', $data['license_id']);
        $stmt->bindParam(':query', $data['query']);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
        $stmt->bindParam(':doc', $doc);
        $stmt->bindParam(':cc_to', $cc_to);
        $stmt->execute();
        $is_proceed_status = 0;
        $is_query_status = 1;
        $stmt_license = SELF::prepare("UPDATE licence_details  SET is_proceed = :is_proceed ,is_query=:is_query WHERE id = :id ");
        $stmt_license->bindParam(':id', $data['license_id']);
        $stmt_license->bindParam(':is_proceed', $is_proceed_status,PDO::PARAM_INT);
        $stmt_license->bindParam(':is_query', $is_query_status,PDO::PARAM_INT);
        $stmt_license->execute();
        return true;
    }

    public function forwardApplication($data){
      $user =  Application::$app->user;
      $workFlowAndZone = $this->getPoliceWorkFlowAndZoneDetails($user);
      $license_status = $this->getLicenseDetails($data);
      $update_query = $this->updateLicenseFlow($workFlowAndZone,$data,$license_status);
      $update = $update_query['update'];
      $stmt = SELF::prepare("UPDATE licence_details SET $update WHERE id = :id ");
      $stmt->bindParam(':id', $data['license_id'], PDO::PARAM_INT);
      $stmt->execute();
      return true;
    }

    public function getLicenseDetails($data){
        $license_stmt = SELF::prepare("SELECT * FROM licence_details  WHERE id = :id");
        $license_stmt->bindParam(':id',$data['license_id'], PDO::PARAM_INT);
        $license_stmt->execute();
        $license_data= $license_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        return $license_data;
    }

   
    public function updateLicenseFlow($policeWorkflowAndZone,$data,$license_status){
        $update = "";
        $index = 0;
        $workFlow = $policeWorkflowAndZone['user_worflow_details'][0]['workflow'];
        if($workFlow == self::LICENCE_WORKFLOW_ONE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
               if($value['flag'] == $license_status['license_department']){
                  $index = $key;
               }
            } 
        }elseif($workFlow == self::WORKFLOW_TWO){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['lando']){
                   $index = $key;
                }
             }
        }elseif($workFlow == self::WORKFLOW_THREE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['traffic']){
                   $index = $key;
                }
             }
        }elseif($workFlow == self::WORKFLOW_FOUR){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['IS_department']){
                   $index = $key;
                }
             }  
        }elseif($workFlow == self::WORKFLOW_FIVE){
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['ccp_department']){
                   $index = $key;
                }
             }
        }else{
            foreach($policeWorkflowAndZone['user_worflow_details'] as $key => $value){
                if($value['flag'] == $license_status['proceeding']){
                   $index = $key;
                }
             }
        }
        $licesne_flow = $this->getLicenseWorkFlow($data);
        $licesne_flow_info = explode(',', $licesne_flow['flow']);
        if( $workFlow == self::LICENCE_WORKFLOW_ONE ){
            if($workFlow && $policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                if($license_status['lando_done'] != SELF::ONE && $license_status['lando'] == 0 ){
                    $update = "";
                    $update .= "license_department = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
                    if(in_array(self::WORKFLOW_TWO,$licesne_flow_info)){
                        $update .= ",lando = ".self::ONE;  
                    }
                    if(in_array(self::WORKFLOW_THREE,$licesne_flow_info)){  
                        $update .= ",traffic = ".self::ONE;  
                    }
                    if(in_array(self::WORKFLOW_FOUR,$licesne_flow_info)){
                        $update .= ",IS_department = ".self::ONE;
                    }
                    if(in_array(self::WORKFLOW_FIVE,$licesne_flow_info)){
                        $update .= ",ccp_department = ".self::ONE;
                    }
                }else{
                    $update = "license_department = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
                    $update .= ",proceeding = ".self::ONE;
                }  
            }else{
                $update = "license_department = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            }
        }
        if($workFlow == self::WORKFLOW_TWO ){
            $update = "lando = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            if($policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                $this->checkAndUpdateOtherFlow($licesne_flow_info,$license_status,'lando_done'); 
                $update .= ",lando_done = ".self::ONE;
            }
        }
        if($workFlow == self::WORKFLOW_THREE ){
            $update = "traffic = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            if($policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                $this->checkAndUpdateOtherFlow($licesne_flow_info,$license_status,'lando_done');
                $update .= ",traffic_done = ".self::ONE;
            }
        }
        if($workFlow == self::WORKFLOW_FOUR){
            $update = "IS_department = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            if($policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                $this->checkAndUpdateOtherFlow($licesne_flow_info,$license_status,'IS_done');  
                $update .= ", IS_done = ".self::ONE;
            }

        }
        if($workFlow  == self::WORKFLOW_FIVE){
            $update = "ccp_department = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            if($policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                $this->checkAndUpdateOtherFlow($licesne_flow_info,$license_status,'ccp_done');
                $update .= ", ccp_done = ".self::ONE;
            }

        }
        if($workFlow == self::WORKFLOW_SIX){
            $update = "proceeding = ".$policeWorkflowAndZone['user_worflow_details'][$index]['next_level'];
            if($policeWorkflowAndZone['user_worflow_details'][$index]['next_level'] == 0 ){
                $this->setLicenseSction($license_status['id']); 
                $update .= ",proceedings_done = ".self::ONE;
            }
        }

        $update_query = [
            "update" =>  $update,
        ];

        return $update_query;
    }

    public function checkAndUpdateOtherFlow($licesne_flow_info,$license_status,$current_field){
        $status = true;
        foreach($licesne_flow_info as $flow){
            if($flow == self::WORKFLOW_TWO && !$current_field == "lando_done" && $license_status['lando_done'] != 1){
                $status = false;
            }
            if($flow == self::WORKFLOW_THREE && !$current_field == "traffic_done" && $license_status['traffic_done'] != 1){
                $status = false;
            }
            if($flow == self::WORKFLOW_FOUR && !$current_field == "IS_done" && $license_status['IS_done'] != 1){
                $status = false;
            }
            if($flow == self::WORKFLOW_FIVE && !$current_field == "ccp_done" && $license_status['ccp_done'] != 1){
                $status = false;
            }
        }
        if( $status){
            $this->setLicenseSction($license_status['id']);
        }
    }

    public function setLicenseSction($license_id){
        $one = self::ONE;
        $licence_stmt = SELF::prepare("UPDATE licence_details SET license_department=:license_department WHERE id =:license_details_id ");
        $licence_stmt->bindParam(':license_department',$one, PDO::PARAM_INT);
        $licence_stmt->bindParam(':license_details_id', $license_id);
        $licence_stmt->execute();
    }

    public function getLicenseWorkFlow($data){
        $licesne_stmt = SELF::prepare("SELECT * FROM licence_details ld INNER JOIN m_licence_workflow lw ON ld.licence_id = lw.licence_id WHERE ld.id = :id");
        $licesne_stmt->bindParam(':id', $data['license_id'], PDO::PARAM_INT);
        $licesne_stmt->execute();
        $licesne_flow= $licesne_stmt->fetch(PDO::FETCH_ASSOC);
        return $licesne_flow;
    }

    public function addMemo($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        
        $remarks = isset($data["remarks"]) ? $data["remarks"] : [];
        if(isset($data['memo_id']) && $data['memo_id'] != " "){
            $stmt_memo_get = SELF::prepare("SELECT * From memo WHERE id = :memo_id");
            $stmt_memo_get->bindParam(':memo_id', $data['memo_id']);
            $stmt_memo_get->execute();
            $stmt_memo_info = $stmt_memo_get->fetchAll(PDO::FETCH_ASSOC)[0];
           
            if($stmt_memo_info['designation_id'] == $userDesignation['designation_id']){
                $stmt = SELF::prepare("UPDATE memo SET designation_id=:designation_id, user_id=:user_id, license_details_id=:license_details_id, our_ref_no=:our_ref_no, to_officer=:to_officer, copy_to=:copy_to WHERE id=:memo_id");
                $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':license_details_id', $data['license_id']);
                $stmt->bindParam(':our_ref_no', $data['our_ref_no']);
                $stmt->bindParam(':to_officer', $data['to_officer']);
                $stmt->bindParam(':copy_to', $data['copy_to']);
                $stmt->bindParam(':memo_id', $data['memo_id']);
                $stmt->execute();
                $stmt_memo_details = SELF::prepare("DELETE FROM memo_details WHERE memo_id=:memo_id");
                $stmt_memo_details->bindParam(':memo_id', $data['memo_id']);
                $stmt_memo_details->execute();  
                $this->addMoreMomoPonits($data['memo_id'],$remarks); 
            }else{
                $memo_id = $this->genMemo($data,$userDesignation,$id);
                $this->addMoreMomoPonits($memo_id,$remarks);
            } 
        }else{
            $memo_id = $this->genMemo($data,$userDesignation,$id);
            $this->addMoreMomoPonits($memo_id,$remarks);
         }
        return true;
    } 

    public function genMemo($data,$userDesignation,$id){
        $stmt_department = SELF::prepare("SELECT * From m_designation WHERE id=:des_id");
        $stmt_department->bindParam(':des_id', $userDesignation['designation_id']);
        $stmt_department->execute();
        $department_details= $stmt_department->fetchAll(PDO::FETCH_ASSOC)[0];

        $stmt = SELF::prepare("INSERT INTO  memo (designation_id,user_id,license_details_id,our_ref_no,to_officer,copy_to,department_id) values (:designation_id,:user_id,:license_details_id,:our_ref_no,:to_officer,:copy_to,:department_id) ");
        $stmt->bindParam(':our_ref_no', $data['our_ref_no']);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':license_details_id', $data['license_id']);
        $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
        $stmt->bindParam(':to_officer', $data['to_officer']);
        $stmt->bindParam(':copy_to', $data['copy_to']);
        $stmt->bindParam(':department_id', $department_details['department_id']);
        $stmt->execute();
        $lastInsertId = Application::$app->db->pdo->lastInsertId('memo');
        $licence_stmt = SELF::prepare("UPDATE licence_details SET is_memo_created=:is_memo_created WHERE id =:license_details_id ");
        $licence_stmt->bindParam(':is_memo_created', $userDesignation['designation_id']);
        $licence_stmt->bindParam(':license_details_id', $data['license_id']);
        $licence_stmt->execute();
        return $lastInsertId;
       
    }
    public function addMoreMomoPonits($memo_id,$data){
            foreach($data as $value){
                $stmt = SELF::prepare("INSERT INTO  memo_details (other_information,memo_id) values (:other_information,:memo_id) ");
                $stmt->bindParam(':other_information', $value);
                $stmt->bindParam(':memo_id', $memo_id);
                $stmt->execute();
            }
    }

    public function viewMemo($id){
        $htmlMemoContent = $this->getUserBasedMemoInfo($id);
        $dompdf = new Dompdf();
        $dompdf->loadHtml($htmlMemoContent);
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream('memo.pdf', array("Attachment" => false));
    }
    
    public function viewHistoryMemo($id){
        $htmlContent = $this->getMemoInfo($id);
        $dompdf = new Dompdf();
        $dompdf->loadHtml($htmlContent);
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream('memohistory.pdf');
    }

    public function getUserBasedMemoInfo($id){
        $licence_stmt = SELF::prepare("SELECT * FROM licence_details ld  WHERE ld.id = :id");
        $licence_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $licence_stmt->execute();
        $license_details= $licence_stmt->fetch(PDO::FETCH_ASSOC);
        $masterObject = new MasterTableModel(); 
        $license_details['zone_id'] = $masterObject->getZoneName($license_details['zone_id']); 
        $html ="";
        $html .= $this->getUserBasedMemoInformation($license_details);
        return $html;
    }
    public function getUserBasedMemoInformation($license_details){
        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
        $license_department = [1,2,3];
        $jc_department = [3,4,5,6,7];
        $memo_details = [];
    
        if (in_array($userDesignation['designation_id'], $license_department)) {
            $memo_info_stmt = self::prepare("SELECT * FROM memo WHERE license_details_id = :license_details_id AND designation_id IN (".implode(',', $license_department).") ");
            $memo_info_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
            $memo_info_stmt->execute();
            $memo_details = $memo_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        elseif (in_array($userDesignation['designation_id'], $jc_department)) {
            $memo_info_stmt = self::prepare("SELECT * FROM memo WHERE license_details_id = :license_details_id AND designation_id IN (".implode(',', $jc_department).") ");
            $memo_info_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
            $memo_info_stmt->execute();
            $memo_details = $memo_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        else {
            $memo_info_stmt = self::prepare("SELECT * FROM memo WHERE license_details_id = :license_details_id AND designation_id = :designation_id ");
            $memo_info_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
            $memo_info_stmt->bindValue(':designation_id', SELF::DESIG_ID_SIX, PDO::PARAM_INT);
            $memo_info_stmt->execute();
            $memo_details = $memo_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        return $this->getUserBasedMemoContent($license_details, $memo_details);
    }

    public function getUserBasedMemoContent($license_details, $memo_details){
        $htmlContent = "";
        $sao = [3,6];
       
        if(!empty($memo_details) && isset($memo_details) && isset($memo_details[0])){
            foreach( $memo_details as $key => $memo) {
                $name = "";

                if (in_array($memo['designation_id'], $sao)) {
                    $user_stmt = SELF::prepare("SELECT first_name FROM users WHERE id = :id");
                    $user_stmt->bindParam(':id', $memo['user_id'], PDO::PARAM_INT);
                    $user_stmt->execute();
                    $user_details= $user_stmt->fetch(PDO::FETCH_ASSOC);
                    $name = $user_details['first_name'];
                }
                
                if($memo['department_id'] == 1){
                    $header = "Office of the Commissioner of Police , GCP";
                    $footer = "For The Commisioner of Poilce , GCP. <br/>".$name;
                }else{
                    $header = "Office of the Joint Commissioner of Police , GCP";
                    $footer = "For The Joint Commissioner  of Poilce , GCP. <br/>".$name;
                }
                $htmlContent .= "<h3 style='margin-left:20px;text-align:center'>".$header."</h3>";
                $memo_others_stmt = self::prepare("SELECT * FROM memo_details WHERE memo_id = :memo_id");
                $memo_others_stmt->bindParam(':memo_id', $memo['id'], PDO::PARAM_INT);
                $memo_others_stmt->execute();
                $memo_other_details = $memo_others_stmt->fetchAll(PDO::FETCH_ASSOC);
              
               
                $remark_stmt = self::prepare("SELECT * FROM licence_comments WHERE license_details_id = :license_details_id AND designation_id= :designation_id");
                $remark_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
                $remark_stmt->bindParam(':designation_id', $memo['designation_id'], PDO::PARAM_INT);
                $remark_stmt->execute();
                $remark_details = $remark_stmt->fetchAll(PDO::FETCH_ASSOC);
    
                $extraPoints = "";
                $index = 3;
                if(!empty($memo_other_details) && isset($memo_other_details) && isset($memo_other_details[0])){
                    foreach ($memo_other_details as $key => $value) {
                        $extraPoints .= '<div class="col-md-12">
                        <h4 style="text-align:center;margin-left:50px;margin-right:50px">
                        '.$index++.') '.$value['other_information'].'</b></h4>
                        </div>';
                    }
                }
                $remarks_points = "<h3>Remarks</h3><br>";
                $index = 1;
                if(!empty($memo_other_details) && isset($remark_details) && isset($memo_other_details[0])){
                    foreach ($remark_details as $key => $remark) {
                        $remarks_points .= '<div class="col-md-12">
                        <h4 style="margin-left:50px;margin-right:50px">
                        '.$index++.') '.$remark['comments'].'</b></h4>
                    </div>';
                    }
                }
                $htmlContent .= $this->htmlContent($license_details,$memo,$extraPoints,$remarks_points,$footer);   
            }
        }
        
        return $htmlContent;
    }

    public function getMemoInfo($id){
        $licence_stmt = SELF::prepare("SELECT * FROM licence_details ld  WHERE ld.id = :id");
        $licence_stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $licence_stmt->execute();
        $license_details= $licence_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        $masterObject = new MasterTableModel(); 
        $license_details['zone_id'] = $masterObject->getZoneName($license_details['zone_id']); 
        $html ="";
        $html .= $this->getMemoInformation($license_details,1);
        $html .= $this->getMemoInformation($license_details,2);
        return $html;
    }

    public function getMemoInformation($license_details,$department){
        $memo_info_stmt = self::prepare("SELECT * FROM memo WHERE license_details_id = :license_details_id AND department_id = :department_id ORDER BY designation_id");
        $memo_info_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
        $memo_info_stmt->bindValue(':department_id', $department, PDO::PARAM_INT);
        $memo_info_stmt->execute();
        $memo_details = $memo_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        if($department == 1){
            $header = "Office of the Commissioner of Police , GCP";
            $footer = "For The Commisioner of Poilce , GCP";
        }else{
            $header = "Office of the Commissioner of Police , GCP";
            $footer = "For The Joint Commissioner  of Poilce , GCP";
        }
        return $this->getMemoContent($license_details, $memo_details,$header,$footer);
    }

    public function getMemoContent($license_details, $memo_details,$header,$footer){
        $htmlContent = "";
        if(!empty($memo_details) && isset($memo_details) && isset($memo_details[0])){
            $htmlContent = "<h3 style='margin-left:20px;text-align:center'>".$header."</h3>";
            foreach( $memo_details as $key => $memo) {
                $memo_others_stmt = self::prepare("SELECT * FROM memo_details WHERE memo_id = :memo_id");
                $memo_others_stmt->bindParam(':memo_id', $memo['id'], PDO::PARAM_INT);
                $memo_others_stmt->execute();
                $memo_other_details = $memo_others_stmt->fetchAll(PDO::FETCH_ASSOC);
              
               
                $remark_stmt = self::prepare("SELECT * FROM licence_comments WHERE license_details_id = :license_details_id AND designation_id= :designation_id");
                $remark_stmt->bindParam(':license_details_id', $license_details['id'], PDO::PARAM_INT);
                $remark_stmt->bindParam(':designation_id', $memo['designation_id'], PDO::PARAM_INT);
                $remark_stmt->execute();
                $remark_details = $remark_stmt->fetchAll(PDO::FETCH_ASSOC);
    
                $extraPoints = "";
                $index = 3;
                if(!empty($memo_other_details) && isset($memo_other_details) && isset($memo_other_details[0])){
                    foreach ($memo_other_details as $key => $value) {
                        $extraPoints .= '<div class="col-md-12">
                        <h4 style="text-align:center;margin-left:50px;margin-right:50px">
                        '.$index++.') '.$value['other_information'].'</b></h4>
                        </div>';
                    }
                }
                $remarks_points = "<h3>Remarks</h3><br>";
                $index = 1;
                if(!empty($memo_other_details) && isset($remark_details) && isset($memo_other_details[0])){
                    foreach ($remark_details as $key => $remark) {
                        $remarks_points .= '<div class="col-md-12">
                        <h4 style="margin-left:50px;margin-right:50px">
                        '.$index++.') '.$remark['comments'].'</b></h4>
                    </div>';
                    }
                }
                $htmlContent .= $this->htmlContent($license_details,$memo,$extraPoints,$remarks_points,$footer);   
            }
        }
        
        return $htmlContent;
    }

    public function htmlContent($license_details,$memo_details,$extraPoints,$remarks_points,$footer){
        
       $html = '<div class="row">
                <div class="col-md-4 form-group " style=""> 
                    <p>'.$license_details["reference_number"].'</p>
                        <span>'.$memo_details['our_ref_no'].' <span>
                </div>
                <div class="col-md-8" style="text-align: right";> 
                    <p>
                        <span>Greater Chennai Police,<span>
                            <br/>
                        <span> Vepery, Chennai – 7. </span>
                        <br/>
                        <!-- <span>12-03-2023</span> -->
                    </p>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <p style="text-align:center"><b>MEMORANDUM</b></p>
                </div>
            </div>

            <div class="row">
                <div class="col-md-12">
                    <p style="text-align:center;margin-left:50px;margin-right:50px">
                    <b>Sub: </b> Greater Chennai Police – Cinema – Renewal “C” Form License
                        of <b>“M/s.'.$license_details['address'].'</b>
                    </p>
                </div>
                <div class="col-md-12">
                    <p style="text-align:center;margin-left:50px;margin-right:50px">
                    <b> Ref:</b> Application dated:-'.$license_details['created_at'].' of the Proprietor of <b> “M/s.
                    '.$license_details['address'].'</b></p>
                </div>
            </div>
            <br/>
            <div class="row">
                <div class="col-md-12">
                    <p style="text-align:center;margin-left:40px;margin-right:40px">
                    1) In this letter cited the proprietor of <b>“M/s.'.$license_details['address'].'</b> has requested for fresh “C” Form License of
                        the said theatre. 
                    </p>
                </div>
                <div class="col-md-12">
                    <p style="text-align:center;margin-left:40px;margin-right:40px">
                        2) <b>The Joint Commissioner of Police, '.$license_details['zone_id'].' Zone </b>is requested to send his
                        verification report along with copy of CCTNS report routed through the remarks
                        of <b>Addl.COP, L&O </b>'.$license_details['zone_id'].' to this office
                    </p>
                </div>
                <div class="col-md-12">
                  '.$extraPoints.'
                </div>
            </div>
            <br/>
            <div class="row">
                <div class="col-md-6">
                    <p style="margin-left:20px"><b>Encl:</b> as said above</p>
                </div>
            </div>

            <div class="row">
                <div class="col-md-8">
                    <p style="text-align:center"></p>
                </div>
                <div class="col-md-6">
                    <p style="margin-left:500px">
                    <span> '.$footer.' </span><br/>
                    </p>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6 form-group">
                    <p style="margin-left:20px"><b>To</b></p>
                    <span style="margin-left:40px">'.$memo_details['to_officer'].' </span>
                </div>
            </div>

            <div class="row">
                <div class="col-md-6 form-group">
                    <p style="margin-left:20px"><b>Copy to</></p>
                <span style="margin-left:40px">'.$memo_details['copy_to'].'</span>
                </div>
            </div>
            <br/><br/>
            <div class="row">
                <div class="col-md-6 form-group">
                  '.$remarks_points.'
                </div>
            </div>
            <div style="page-break-before: always;"></div>
            
        </div>';
        return $html;
    }

    public function addOfficerCheckList($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $data["zone_id"] = $userDesignation['zone_id'];
        $data["user_id"] = $userDesignation['user_id'];
        $data["designation_id"] = $userDesignation['designation_id'];
        
        $tableName = "officer_theater_checklist";
        $attributes = $this->getAttributesFromRequest($data);
       
        if(isset($data['edit_id']) && $data['edit_id'] != " "){
            $delete_check_stmt= self::prepare("DELETE FROM $tableName  WHERE id = :edit_id");
            $delete_check_stmt->bindValue(":edit_id", $data["edit_id"]);
            $delete_check_stmt->execute();
        }
        $param = array_map(fn($attr) => ":$attr", $attributes);
        $statement = self::prepare("INSERT INTO $tableName (" . implode(",", $attributes) . ") 
            VALUES (" . implode(",", $param) . ")");
        foreach ($attributes as $attribute) {
            $statement->bindValue(":$attribute", $data[$attribute]);
        }
        $statement->execute();
        
        return true;
    }

    public function getAttributesFromRequest($data): array
    {
        $attributes =[];
        foreach ($data as $key => $value) {
            
            if($key != 'edit_id'){
                $attributes[] = $key;
            }
        }
        return $attributes;
    }

    public function addDocs($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $stmt = SELF::prepare("INSERT INTO  officers_docs (doc,designation_id,user_id,license_details_id) values (:doc,:m_designation_id,:user_id,:license_details_id) ");
        $stmt->bindParam(':doc', $data['docs']);
        $stmt->bindParam(':m_designation_id', $userDesignation['designation_id']);
        $stmt->bindParam(':user_id', $userDesignation['user_id']);
        $stmt->bindParam(':license_details_id', $data['license_id']);
        $stmt->execute();
        return true;
    }

    public function removeDocs($data){
        unlink('docs/'.$data['img']);
        $stmt = SELF::prepare("DELETE FROM  officers_docs WHERE id=:id ");
        $stmt->bindParam(':id', $data['imgId']);
        $stmt->execute();
        return true;
    }

    public function UpdateVerification($data){
        $licence_stmt = self::prepare("UPDATE licence_details SET doc_verified = :doc_verified WHERE id = :license_details_id");
        $doc_verified_value = 1; 
        $licence_stmt->bindParam(':doc_verified', $doc_verified_value, PDO::PARAM_INT);
        $licence_stmt->bindParam(':license_details_id', $data['license_id'], PDO::PARAM_INT);
        $licence_stmt->execute();        
        return true;
    }

    public function memoApproval($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $value = self::ONE;
        if($userDesignation['designation_id'] == self::DESIG_ID_THREE){
            $memo_id = $this->insertMemoDetailsIfNotExist($userDesignation,$data);
            $stmt = SELF::prepare("UPDATE memo SET license_sho_approval=:license_sho_approval WHERE id=:memo_id");
            $stmt->bindParam(':license_sho_approval',$value,PDO::PARAM_INT);
            $stmt->bindParam(':memo_id', $memo_id,PDO::PARAM_INT);
            $stmt->execute();
        }
        if($userDesignation['designation_id'] == self::DESIG_ID_SIX){
            $memo_id = $this->insertMemoDetailsIfNotExist($userDesignation,$data);
            $stmt = SELF::prepare("UPDATE memo SET jc_sho_approval=:jc_sho_approval WHERE id=:memo_id");
            $stmt->bindParam(':jc_sho_approval',$value,PDO::PARAM_INT);
            $stmt->bindParam(':memo_id', $memo_id,PDO::PARAM_INT);
            $stmt->execute();        
        }
        if($userDesignation['designation_id'] == self::DESIG_ID_SEVEN){
            $stmt = SELF::prepare("UPDATE memo SET jc_approval=:jc_approval WHERE id = :memo_id");
            $stmt->bindParam(':jc_approval',$value,PDO::PARAM_INT);
            $stmt->bindParam(':memo_id', $data['memo_id'],PDO::PARAM_INT);
            $stmt->execute();        
        }
        return true;
    }

    public function insertMemoDetailsIfNotExist($userDesignation,$data){
        $lastInsertId = $data['memo_id'];
        $stmt_department = SELF::prepare("SELECT * From m_designation WHERE id=:des_id");
        $stmt_department->bindParam(':des_id', $userDesignation['designation_id']);
        $stmt_department->execute();
        $department_details= $stmt_department->fetchAll(PDO::FETCH_ASSOC)[0];
        
        $memo_info_stmt = self::prepare("SELECT * FROM memo WHERE license_details_id = :license_details_id AND department_id = :department_id ORDER BY designation_id DESC LIMIT 1");
        $memo_info_stmt->bindParam(':license_details_id', $data['license_id'], PDO::PARAM_INT);
        $memo_info_stmt->bindValue(':department_id', $department_details['department_id'], PDO::PARAM_INT);
        $memo_info_stmt->execute();
        $memo_details = $memo_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        if(!empty($memo_details)){
             if($memo_details[0]['designation_id'] != $department_details['id']){
                $stmt = SELF::prepare("INSERT INTO  memo (designation_id,user_id,license_details_id,our_ref_no,to_officer,copy_to,department_id) values (:designation_id,:user_id,:license_details_id,:our_ref_no,:to_officer,:copy_to,:department_id) ");
                $stmt->bindParam(':our_ref_no', $data['our_ref_no']);
                $stmt->bindParam(':user_id', $userDesignation['user_id']);
                $stmt->bindParam(':license_details_id', $data['license_id']);
                $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
                $stmt->bindParam(':to_officer', $data['to_officer']);
                $stmt->bindParam(':copy_to', $data['copy_to']);
                $stmt->bindParam(':department_id', $department_details['department_id']);
                $stmt->execute();
                $lastInsertId = Application::$app->db->pdo->lastInsertId('memo');
                $this->addMoreMomoPonits($lastInsertId,$data['remarks']);
             }
        }
        return $lastInsertId;
    } 

    public function addNotes($data){
      
            $id =  Application::$app->user ? Application::$app->user->id : 0;
            $userDesignation = $this->getUserDesignation($id);
            $stmt_department = SELF::prepare("SELECT * From m_designation WHERE id=:des_id");
            $stmt_department->bindParam(':des_id', $userDesignation['designation_id']);
            $stmt_department->execute();
            $department_details= $stmt_department->fetchAll(PDO::FETCH_ASSOC)[0];
            $currentTimestamp = time();
            $randomNumber = rand();
            $ref_no = $currentTimestamp . $randomNumber;
            $stmt = SELF::prepare("INSERT INTO  license_notes (notes,department_id,designation_id,user_id,ref_no,license_details_id) values (:notes,:department_id,:designation_id,:user_id,:ref_no,:license_details_id) ");
            $stmt->bindParam(':notes', $data['notes']);
            $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
            $stmt->bindParam(':user_id', $userDesignation['user_id']);
            $stmt->bindParam(':license_details_id', $data['license_id']);
            $stmt->bindParam(':ref_no', $ref_no);
            $stmt->bindParam(':department_id', $department_details['department_id']);
            $stmt->execute();
            return true;
    }

    public function addMultiNotes($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        
        if(isset($data['notes_id']) && $data['notes_id'] != " "){
            $stmt_notes_get = SELF::prepare("SELECT * From license_notes WHERE id = :notes_id");
            $stmt_notes_get->bindParam(':notes_id', $data['notes_id']);
            $stmt_notes_get->execute();
            $stmt_notes_info = $stmt_notes_get->fetch(PDO::FETCH_ASSOC);
            $notes = json_encode($data['notes']);
            if($stmt_notes_info['designation_id'] == $userDesignation['designation_id']){
                $stmt = SELF::prepare("UPDATE license_notes SET  notes=:notes WHERE id=:notes_id");
                $stmt->bindParam(':notes_id', $data['notes_id']);
                $stmt->bindParam(':notes', $notes);
                $stmt->execute();
            }else{
                $this->genNotes($data,$userDesignation);
            } 
        }else{
            $this->genNotes($data,$userDesignation);
         }  
       
        return true;
    }

    public function genNotes($data,$userDesignation){
        $stmt_department = SELF::prepare("SELECT * From m_designation WHERE id=:des_id");
        $stmt_department->bindParam(':des_id', $userDesignation['designation_id']);
        $stmt_department->execute();
        $department_details= $stmt_department->fetchAll(PDO::FETCH_ASSOC)[0];
        $currentTimestamp = time();
        $randomNumber = rand();
        $ref_no = $currentTimestamp . $randomNumber;
        $currentDate = date("Y-m-d");
        $notes = json_encode($data['notes']);
        $stmt = SELF::prepare("INSERT INTO  license_notes (notes,department_id,designation_id,user_id,ref_no,license_details_id,created_at) values (:notes,:department_id,:designation_id,:user_id,:ref_no,:license_details_id,:created_at) ");
        $stmt->bindParam(':notes', $notes);
        $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
        $stmt->bindParam(':user_id', $userDesignation['user_id']);
        $stmt->bindParam(':license_details_id', $data['license_id']);
        $stmt->bindParam(':ref_no', $ref_no);
        $stmt->bindParam(':department_id', $department_details['department_id']);
        $stmt->bindParam(':created_at', $currentDate);
        $stmt->execute();
    }


    function viewNotes($id){
        $htmlNotesContent = $this->getUserBasedNotesInfo($id);
        $dompdf = new Dompdf();
        $dompdf->loadHtml($htmlNotesContent);
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream('memo.pdf', array("Attachment" => false));
    }

    public function getUserBasedNotesInfo($id){
        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
        $license_department = [1,2,3];
        $jc_department = [3,4,5,6,7];
        $notes_details = [];
        if (in_array($userDesignation['designation_id'], $license_department)) {
            $notes_info_stmt = self::prepare("SELECT * FROM license_notes WHERE license_details_id = :license_details_id AND designation_id IN (".implode(',', $license_department).") ");
            $notes_info_stmt->bindParam(':license_details_id', $id, PDO::PARAM_INT);
            $notes_info_stmt->execute();
            $notes_details = $notes_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        elseif (in_array($userDesignation['designation_id'], $jc_department)) {
            $notes_info_stmt = self::prepare("SELECT * FROM license_notes WHERE license_details_id = :license_details_id AND designation_id IN (".implode(',', $jc_department).")  ORDER BY designation_id ASC");
            $notes_info_stmt->bindParam(':license_details_id', $id, PDO::PARAM_INT);
            $notes_info_stmt->execute();
            $notes_details = $notes_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        else {
            $notes_info_stmt = self::prepare("SELECT * FROM license_notes WHERE license_details_id = :license_details_id AND designation_id = :designation_id ");
            $notes_info_stmt->bindParam(':license_details_id', $id, PDO::PARAM_INT);
            $notes_info_stmt->bindValue(':designation_id', SELF::DESIG_ID_SIX, PDO::PARAM_INT);
            $notes_info_stmt->execute();
            $notes_details = $notes_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        return $this->getUserBasedNotesContent($notes_details);
    }


    public function getUserBasedNotesContent($notes_details){
        $header = "Office of the Commissioner of Police , GCP";
        $htmlContent = "<h3 style='margin-left:20px;text-align:center'>".$header."</h3>";
        if(!empty($notes_details) && isset($notes_details) && isset($notes_details[0])){
            foreach( $notes_details as $key => $notes) {   
                $data = json_decode($notes['notes']);
                $notes_des_stmt = self::prepare("SELECT * FROM m_designation WHERE id = :id");
                $notes_des_stmt->bindParam(':id', $notes['designation_id'], PDO::PARAM_INT);
                $notes_des_stmt->execute();
                $notes_des_details = $notes_des_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
                $htmlContent .= "<br/><h3 style='margin-left:20px;text-align:left'>".$notes_des_details['designation']."</h3>"; 
                if ($data !== null) {
                    foreach ($data as $item) {
                        $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>".$item."</hp>"; 
                    }
                } 
                 
            }
        }
        return $htmlContent;   
    }

    public function memoPreview($data){
        $footer = "";
        $extraPoints = "";
        $licence_stmt = SELF::prepare("SELECT * FROM licence_details ld  WHERE ld.id = :id");
        $licence_stmt->bindParam(':id', $data['license_id'], PDO::PARAM_INT);
        $licence_stmt->execute();
        $license_details= $licence_stmt->fetchAll(PDO::FETCH_ASSOC)[0];
        $masterObject = new MasterTableModel(); 
        $license_details['zone_id'] = $masterObject->getZoneName($license_details['zone_id']); 

        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
        $license_department = [1,2,3];

        $extraPoints = "";
        $index = 3;
        if(!empty($data['remarks']) && isset($data['remarks'])){
            foreach ($data['remarks'] as $key => $value) {
                $extraPoints .= '<div class="col-md-12">
                <h4 style="text-align:center;margin-left:50px;margin-right:50px">
                '.$index++.') '.$value.'</b></h4>
                </div>';
            }
        }

        if(in_array($userDesignation['designation_id'], $license_department)){
            $header = "Office of the Commissioner of Police , GCP";
            $footer = "For The Commisioner of Poilce , GCP";
        }else{
            $header = "Office of the Joint Commissioner of Police , GCP";
            $footer = "For The Joint Commissioner  of Poilce , GCP";
        }

        $html = '<h3 style="margin-left:20px;text-align:center">'.$header.'</h3>
                <div class="row">
                    <div class="col-md-4 form-group " style=""> 
                        <p>'.$license_details["reference_number"].'</p>
                            <span>'.$data['our_ref_no'].' <span>
                    </div>
                    <div class="col-md-8" style="text-align: right";> 
                        <p>
                            <span>Greater Chennai Police,<span>
                                <br/>
                            <span> Vepery, Chennai – 7. </span>
                            <br/>
                            <!-- <span>12-03-2023</span> -->
                        </p>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <p style="text-align:center"><b>MEMORANDUM</b></p>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-12">
                        <p style="text-align:center;margin-left:50px;margin-right:50px">
                        <b>Sub: </b> Greater Chennai Police – Cinema – Renewal “C” Form License
                            of <b>“M/s.'.$license_details['address'].'</b>
                        </p>
                    </div>
                    <div class="col-md-12">
                        <p style="text-align:center;margin-left:50px;margin-right:50px">
                        <b> Ref:</b> Application dated:-'.$license_details['created_at'].' of the Proprietor of <b> “M/s.
                        '.$license_details['address'].'</b></p>
                    </div>
                </div>
                <br/>
                <div class="row">
                    <div class="col-md-12">
                        <p style="text-align:center;margin-left:40px;margin-right:40px">
                        1) In this letter cited the proprietor of <b>“M/s.'.$license_details['address'].'</b> has requested for fresh “C” Form License of
                            the said theatre. 
                        </p>
                    </div>
                    <div class="col-md-12">
                        <p style="text-align:center;margin-left:40px;margin-right:40px">
                            2) <b>The Joint Commissioner of Police, '.$license_details['zone_id'].' Zone </b>is requested to send his
                            verification report along with copy of CCTNS report routed through the remarks
                            of <b>Addl.COP, L&O </b>'.$license_details['zone_id'].' to this office
                        </p>
                    </div>
                    <div class="col-md-12">
                    '.$extraPoints.'
                    </div>
                </div>
                <br/>
                <div class="row">
                    <div class="col-md-6">
                        <p style="margin-left:20px"><b>Encl:</b> as said above</p>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-8">
                        <p style="text-align:center"></p>
                    </div>
                    <div class="col-md-6">
                        <p style="text-align:right">
                        <span> '.$footer.' </span><br/>
                        </p>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6 form-group">
                        <p style="margin-left:20px"><b>To</b></p>
                        <span style="margin-left:40px">'.$data['to_officer'].' </span>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-6 form-group">
                        <p style="margin-left:20px"><b>Copy to</></p>
                    <span style="margin-left:40px">'.$data['copy_to'].'</span>
                    </div>
                </div>
                <br/><br/>
                <div style="page-break-before: always;"></div>
                
            </div>';
          
        echo  $html;
    }

    public function addReport($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $doc ="";
       
        if(isset($data['report_id']) && !empty($data['report_id'])){
            if (!$_FILES["doc"]['size'] === 0 || $_FILES["doc"]['error'] == UPLOAD_ERR_OK) {
                $fileUpload = new FileUpload();
                $doc = $fileUpload->upload($_FILES["doc"]);
            }else{
                $doc = $data['doc_old'];
            }
            $stmt = SELF::prepare("UPDATE license_report SET license_details_id=:license_details_id ,designation_id=:designation_id , user_id=:user_id , I_O=:I_O , 
            created_by=:created_by ,field_visited_by=:field_visited_by ,recommended=:recommended,doc=:doc  WHERE id=:report_id");
             $stmt->bindParam(':license_details_id', $data['license_id']);
             $stmt->bindParam(':I_O', $data['io']);
             $stmt->bindParam(':user_id', $id);
             $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
             $stmt->bindParam(':doc', $doc);
             $stmt->bindParam(':created_by', $data['created_by']);
             $stmt->bindParam(':field_visited_by', $data['field_visited_by']);
             $stmt->bindParam(':recommended', $data['recommended']);
             $stmt->bindParam(':report_id', $data['report_id']);
             $stmt->execute();   
             return true;     
        }else{
            if (!$_FILES["doc"]['size'] === 0 || $_FILES["doc"]['error'] == UPLOAD_ERR_OK) {
                $fileUpload = new FileUpload();
                $doc = $fileUpload->upload($_FILES["doc"]);
            }
            $stmt = SELF::prepare("INSERT INTO license_report (license_details_id,designation_id,doc,user_id,I_O,created_by,field_visited_by,recommended) values (:license_details_id,:designation_id,:doc,:user_id,:I_O,:created_by,:field_visited_by,:recommended) ");
            $stmt->bindParam(':license_details_id', $data['license_id']);
            $stmt->bindParam(':I_O', $data['io']);
            $stmt->bindParam(':user_id', $id);
            $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
            $stmt->bindParam(':doc', $doc);
            $stmt->bindParam(':created_by', $data['created_by']);
            $stmt->bindParam(':field_visited_by', $data['field_visited_by']);
            $stmt->bindParam(':recommended', $data['recommended']);
            $stmt->execute();
            $is_report_created = 1;
            $stmt_license = SELF::prepare("UPDATE licence_details SET is_report_created=:is_report_created WHERE id=:id");
            $stmt_license->bindParam(':is_report_created',$is_report_created,PDO::PARAM_INT);
            $stmt_license->bindParam(':id', $data['license_id'],PDO::PARAM_INT);
            $stmt_license->execute();  
            return true;
        }
    }

    public function viewReports($id){
        $htmlReportsContent = $this->getReportsInfo($id);
        $dompdf = new Dompdf();
        $dompdf->loadHtml($htmlReportsContent);
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream('memo.pdf', array("Attachment" => false));
    }

    public function getReportsInfo($id){
        $report_info_stmt = self::prepare("SELECT * FROM  license_report lr INNER JOIN licence_details ld ON lr.license_details_id = ld.id  WHERE license_details_id = :license_details_id ORDER BY designation_id DESC ");
        $report_info_stmt->bindParam(':license_details_id', $id, PDO::PARAM_INT);
        $report_info_stmt->execute();
        $report_details = $report_info_stmt->fetchAll(PDO::FETCH_ASSOC);
        $header = "Office of the Commissioner of Police , GCP";
        $htmlContent = "<h3 style='margin-left:20px;text-align:center'>".$header."</h3>";
        if(!empty($report_details) && isset($report_details) ){
            foreach( $report_details as $key => $report) {   
                $report_des_stmt = self::prepare("SELECT * FROM m_designation WHERE id = :id");
                $report_des_stmt->bindParam(':id', $report['designation_id'], PDO::PARAM_INT);
                $report_des_stmt->execute();
                $report_des_details = $report_des_stmt->fetch(PDO::FETCH_ASSOC);
                $recommended = $report['recommended'] == 1 ? "Yes" : "No";
                isset($report_des_details['designation']) ? $htmlContent .= "<br/><h3 style='margin-left:20px;text-align:left'>".$report_des_details['designation']."</h3>" : "";  
                isset($report['I_O']) && $report['I_O'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>IO : ".$report['I_O']."</hp>": "";  
                isset($report['created_by']) && $report['created_by'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>Created by : ".$report['created_by']."</hp>" : "";  
                isset($report['field_visited_by']) && $report['field_visited_by'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>Field Visit by : ".$report['field_visited_by']."</hp>" : "";  
                isset($report['I_O']) && $report['I_O'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>Date : ".$report['date']."</hp>" : "";  
                isset($report['I_O']) && $report['I_O'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>Time : ".$report['time']."</hp>" : "";  
                isset($report['I_O']) && $report['I_O'] ? $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>Recommended : ".$recommended."</hp>" : "";   
                $notes = json_decode($report['notes']);
                if ($notes !== null) {
                    foreach ($notes as $item) {
                        $htmlContent .= "<br/><p style='margin-left:20px;text-align:left'>".$item."</hp>"; 
                    }
                } 
                
            }
        }
        return $htmlContent;  
    }

    public function getNotesDetails($license_id){
        $masterObject = new MasterTableModel(); 
        $getPoliceDesignations = $masterObject->getPoliceDesignations();
        $designation_id = $getPoliceDesignations[0]['id'];
        $dep_stmt = SELF::prepare("SELECT * FROM m_designation WHERE id = :id");
        $dep_stmt->bindParam(':id', $designation_id, PDO::PARAM_INT);
        $dep_stmt->execute();
        $department_details = $dep_stmt->fetch(PDO::FETCH_ASSOC);
        $license = [1,2,3,4,5,6];
        if(in_array($designation_id,$license)){
            $notes_stmt = self::prepare("SELECT * FROM license_notes WHERE license_details_id = :id AND department_id = :department_id ORDER BY designation_id DESC LIMIT 1");
            $notes_stmt->bindParam(':department_id', $department_details['department_id'], PDO::PARAM_INT);
        }else{
            $notes_stmt = self::prepare("SELECT * FROM license_notes WHERE license_details_id = :id AND designation_id = :designation_id");
            $notes_stmt->bindParam(':designation_id', $designation_id, PDO::PARAM_INT);
        }
        $notes_stmt->bindParam(':id', $license_id, PDO::PARAM_INT);
        $notes_stmt->execute();
        $notes_details = $notes_stmt->fetch(PDO::FETCH_ASSOC);
        return $notes_details;
    }

    public function isAllReport(){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        $isAllReport = false;
        $allReport = [10];
        if(in_array($userDesignation['designation_id'],$allReport)){
            $isAllReport = true;
        }
        return  $isAllReport;
    }

    public function getReportDetails($license_id){
        $masterObject = new MasterTableModel(); 
        $getPoliceDesignations = $masterObject->getPoliceDesignations();
        $designation_id = $getPoliceDesignations[0]['id'];
        $dep_stmt = SELF::prepare("SELECT * FROM m_designation WHERE id = :id");
        $dep_stmt->bindParam(':id', $designation_id, PDO::PARAM_INT);
        $dep_stmt->execute();
        $department_details = $dep_stmt->fetch(PDO::FETCH_ASSOC);
        $department_id = $department_details['department_id'];
        $license = [1,2,3];
        $jc_license = [4,5,6];

        if(in_array($designation_id,$license)){
           return $this->getReportInfo($department_id,$license_id);
        }elseif(in_array($designation_id,$jc_license)){
            return $this->getReportInfo($department_id,$license_id);
        }else{
            $report_stmt = self::prepare("SELECT * FROM license_report WHERE license_details_id = :id AND designation_id = :designation_id");
            $report_stmt->bindParam(':id', $license_id, PDO::PARAM_INT);
            $report_stmt->bindParam(':designation_id', $designation_id, PDO::PARAM_INT);
            $report_stmt->execute();
            $report_details = $report_stmt->fetch(PDO::FETCH_ASSOC);
            return $report_details;
        }
    }

    public function getReportInfo($department_id,$license_id){
        if($department_id == 2){
            $report_stmt = self::prepare("SELECT * FROM license_report WHERE license_details_id = :id AND department_id = :department_id AND designation_id IN (4,5,6)  ORDER BY designation_id DESC LIMIT 1");
        }else{
            $report_stmt = self::prepare("SELECT * FROM license_report WHERE license_details_id = :id AND department_id = :department_id  ORDER BY designation_id DESC LIMIT 1"); 
        }
        
        $report_stmt->bindParam(':id', $license_id, PDO::PARAM_INT);
        $report_stmt->bindParam(':department_id', $department_id, PDO::PARAM_INT);
        $report_stmt->execute();
        $report_details = $report_stmt->fetch(PDO::FETCH_ASSOC);
        return $report_details;
    }

    public function insertReport($data){
        $user_id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($user_id);
       
        if(isset($data['report_id']) && !empty($data['report_id'])){
            $stmt_notes_get = SELF::prepare("SELECT * From license_report WHERE id = :report_id");
            $stmt_notes_get->bindParam(':report_id', $data['report_id']);
            $stmt_notes_get->execute();
            $stmt_notes_info = $stmt_notes_get->fetch(PDO::FETCH_ASSOC);

            if($stmt_notes_info['designation_id'] == $userDesignation['designation_id']){
                $io = isset($data['io']) ? $data['io'] : "";
                $created_by = isset($data['created_by']) ? $data['created_by'] : "";
                $field_visited_by = isset($data['field_visited_by']) ? $data['field_visited_by'] : "";
                $recommended = isset($data['recommended']) ? $data['recommended'] : "";
                $notes = isset($data['notes']) ?  json_encode($data['notes']): ""; 
               
                $stmt = SELF::prepare("UPDATE license_report SET license_details_id=:license_details_id ,designation_id=:designation_id , user_id=:user_id , I_O=:I_O , 
                created_by=:created_by ,field_visited_by=:field_visited_by ,recommended=:recommended,doc=:doc ,notes=:notes WHERE id=:report_id");
                $stmt->bindParam(':license_details_id', $data['license_id']);
                $stmt->bindParam(':I_O', $io);
                $stmt->bindParam(':user_id', $user_id);
                $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
                $stmt->bindParam(':doc', $doc);
                $stmt->bindParam(':created_by', $created_by);
                $stmt->bindParam(':field_visited_by',$field_visited_by);
                $stmt->bindParam(':recommended', $recommended);
                $stmt->bindParam(':report_id', $data['report_id']);
                $stmt->bindParam(':notes', $notes);
                $stmt->execute();  
            }else{
                $this->genReports($data,$userDesignation,$user_id);
            } 
        }else{
            $this->genReports($data,$userDesignation,$user_id);
         }
    }

    public function genReports($data,$userDesignation,$user_id){
            $doc = "";
           
            if (isset($_FILES["doc"])) {
                if(!$_FILES["doc"]['size'] === 0 || $_FILES["doc"]['error'] == UPLOAD_ERR_OK){
                    $fileUpload = new FileUpload();
                    $doc = $fileUpload->upload($_FILES["doc"]);
                }  
            }
            $io = isset($data['io']) ? $data['io'] : "";
            $created_by = isset($data['created_by']) ? $data['created_by'] : "";
            $field_visited_by = isset($data['field_visited_by']) ? $data['field_visited_by'] : "";
            $recommended = isset($data['recommended']) ? $data['recommended'] : "";
            $notes = isset($data['notes']) ?  json_encode($data['notes']) : "";
            
            $dep_stmt = SELF::prepare("SELECT * FROM m_designation WHERE id = :id");
            $dep_stmt->bindParam(':id', $userDesignation['designation_id'], PDO::PARAM_INT);
            $dep_stmt->execute();
            $department_details = $dep_stmt->fetch(PDO::FETCH_ASSOC);
            $department_id = $department_details['department_id'];
           
            $stmt = SELF::prepare("INSERT INTO license_report (license_details_id,designation_id,doc,user_id,I_O,
            created_by,field_visited_by,recommended,notes,department_id) values (:license_details_id,:designation_id,:doc,
            :user_id,:I_O,:created_by,:field_visited_by,:recommended,:notes,:department_id) ");
            $stmt->bindParam(':license_details_id', $data['license_id']);
            $stmt->bindParam(':I_O', $data['io']);
            $stmt->bindParam(':user_id', $user_id);
            $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
            $stmt->bindParam(':doc', $doc);
            $stmt->bindParam(':created_by', $data['created_by']);
            $stmt->bindParam(':field_visited_by', $data['field_visited_by']);
            $stmt->bindParam(':recommended', $data['recommended']);
            $stmt->bindParam(':notes', $notes);
            $stmt->bindParam(':department_id', $department_id);
            $stmt->execute();
            $is_report_created = 1;
            $stmt_license = SELF::prepare("UPDATE licence_details SET is_report_created=:is_report_created WHERE id=:id");
            $stmt_license->bindParam(':is_report_created',$is_report_created,PDO::PARAM_INT);
            $stmt_license->bindParam(':id', $data['license_id'],PDO::PARAM_INT);
            $stmt_license->execute();  
    }

    public function addReverseRemarks($data){
        $id =  Application::$app->user ? Application::$app->user->id : 0;
        $userDesignation = $this->getUserDesignation($id);
        foreach($data["remarks"] as  $value){
            $stmt = SELF::prepare("INSERT INTO  licence_reverse_remarks (license_details_id,comments,user_id,designation_id) values (:license_details_id,:comments,:user_id,:designation_id) ");
            $stmt->bindParam(':license_details_id', $data['license_id']);
            $stmt->bindParam(':comments', $value);
            $stmt->bindParam(':user_id', $id);
            $stmt->bindParam(':designation_id', $userDesignation['designation_id']);
            $stmt->execute();
        }
        return true;
    }



}

?>