<?php
namespace app\src\models;
use app\src\core\Model;
use app\src\core\Application;
class MasterTableModel extends Model{

    public function getAllCountry(){
        $statement = self::prepare("SELECT * FROM m_country");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getAllState(){
        $statement = self::prepare("SELECT * FROM m_state");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getAllCity(){
        $statement = self::prepare("SELECT * FROM m_city");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getCountryState($country){
        $statement = self::prepare("SELECT * FROM m_state where country_id = $country");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getStateCity($state){
        $statement = self::prepare("SELECT * FROM m_city where state_id = $state");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getPoliceStations(){
        $statement = self::prepare("SELECT * FROM police_station");
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getPoliceDesignations(){
        $user_id =  Application::$app->user ? Application::$app->user->id : "0";
        $user_role_mapping_stmt = self::prepare("SELECT * FROM user_role_mapping WHERE user_id = :user_id");
        $user_role_mapping_stmt->bindParam(':user_id',$user_id, \PDO::PARAM_INT);
        $user_role_mapping_stmt->execute();
        $user_role_mapping_data = $user_role_mapping_stmt->fetchAll(\PDO::FETCH_ASSOC)[0] ?? [];

        $statement = self::prepare("SELECT * FROM m_designation WHERE id = :designation_id ");
        $statement->bindParam(':designation_id',$user_role_mapping_data['designation_id'], \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC);
        return $records;
    }

    public function getPoliceStationName($id){
        $statement = self::prepare("SELECT * FROM police_station where id = :id");
        $statement->bindParam(':id', $id, \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC)[0]["name"];
        return $records;
    }

    public function getCountryName($id){
        $statement = self::prepare("SELECT * FROM m_country where id = :id");
        $statement->bindParam(':id', $id, \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC)[0]["name"];
        return $records;
    }

    public function getStateName($id){
        $statement = self::prepare("SELECT * FROM m_state where id = :id");
        $statement->bindParam(':id', $id, \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC)[0]["name"];
        return $records;
    }

    public function getCityName($id){
        $statement = self::prepare("SELECT * FROM m_city where id = :id");
        $statement->bindParam(':id', $id, \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC)[0]["name"];
        return $records;
    }

    public function getZoneName($zone_id){
        $statement = self::prepare("SELECT name FROM zone where id = :id");
        $statement->bindParam(':id', $zone_id, \PDO::PARAM_INT);
        $statement->execute();
        $records = $statement->fetchAll(\PDO::FETCH_ASSOC)[0]["name"];
        return $records;
    }

}

?>