<div class="col-md-7 mt-5 col-lg-6 ml-auto">
<div style="display: none;" class="alert alert-danger alert-dismissible fade show" role="alert" id="alert-msg">
  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
</div>
<div style="display: none;" class="alert alert-success alert-dismissible fade show" role="alert" id="alert-success-msg">
  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
</div>
    <form id="registration"  name="register" method="POST">
        <div class="row">

            <!-- User Type -->
            <div class="input-group col-lg-12 mb-4">
                <div class="input-group-prepend">
                    <span class="input-group-text bg-white px-4 border-md border-right-0 filed-error-label" id="user_type_label">
                        <i class="fa fa-list text-muted"></i>
                    </span>
                </div>
                <select class="form-control bg-white border-left-0 border-md" id="user_type" name="user_type" style="height: calc(4.25rem + 2px);">
                   <option value=""> - Select Here - </option>
                   <?php foreach($user_types as $user_type) : ?>    
                        <option value="<?php echo $user_type['id']; ?>"><?php echo $user_type['name']; ?></option>
                    <?php endforeach; ?>
                </select>
                <div class="invalid-feedback" id="invalid-user_type"></div>
            </div>
            
            <div class="input-group col-lg-6 mb-4 pub_div" id="first_name_div">
                <div class="input-group-prepend">
                    <span class="input-group-text bg-white px-4 border-md border-right-0 filed-error-label" id="first_name_label">
                        <i class="fa fa-user text-muted"></i>
                    </span>
                </div>
                <input id="first_name" type="text" name="first_name" placeholder="First Name" class="form-control bg-white border-left-0 border-md">
                <div class="invalid-feedback" id="invalid-first_name"></div>
            </div>

            <!-- Last Name -->
            <div class="input-group col-lg-6 mb-4 pub_div">
                <div class="input-group-prepend">
                    <span class="input-group-text bg-white px-4 border-md border-right-0 filed-error-label" id="last_name_label">
                        <i class="fa fa-user text-muted"></i>
                    </span>
                </div>
                <input id="last_name" type="text" name="last_name" placeholder="Last Name" class="form-control bg-white border-left-0 border-md">
                <div class="invalid-feedback" id="invalid-last_name"></div>
            </div>

            <!-- Email Address -->
            <div class="input-group col-lg-12 mb-4">
                <div class="input-group-prepend">
                    <span class="input-group-text bg-white px-4 border-md border-right-0 filed-error-label" id="email_label">
                        <i class="fa fa-envelope text-muted"></i>
                    </span>
                </div>
                <input id="email" type="text" name="email" placeholder="Email Address" class="form-control bg-white border-left-0 border-md">
                <div class="invalid-feedback" id="invalid-email"></div>
            </div>

            <!-- Phone Number -->
            <div class="input-group col-lg-12 mb-4">
                <div class="input-group-prepend">
                    <span class="input-group-text bg-white px-4 border-md border-right-0 filed-error-label" id="phone_label">
                        <i class="fa fa-phone-square text-muted"></i>
                    </span>
                </div>
                <input id="phone" type="tel" name="phone" placeholder="Phone Number" class="form-control bg-white border-md border-left-0 pl-3">
                <div class="invalid-feedback" id="invalid-phone"></div>
            </div>
            

            <!-- Submit Button -->
            <div class="form-group col-lg-6 mx-auto mb-0 ">
                <button type="button" id="submit-btn" class="btn btn-primary btn-block py-2">
                    <span class="font-weight-bold">Submit</span>
                </button>
            </div>
            <div class="form-group col-lg-6 mx-auto mb-0 ">
                <button type="reset" class="btn btn-danger btn-block py-2">
                    <span class="font-weight-bold" >Clear</span>
                </button>
            </div>
           
            <!-- Divider Text -->
            <div class="form-group col-lg-12 mx-auto d-flex align-items-center my-4">
                <div class="border-bottom w-100 ml-5"></div>
            </div>

            <div class="text-center w-100">
                <p class="text-muted font-weight-bold">Already Registered? <a href="/login" class="text-primary ml-2">Login</a></p>
            </div>
        </div>
    </form>
</div>
<script src="assets/js/formSubmit.js"></script>
<script>
    $("#submit-btn").on('click',(function(e){
        e.preventDefault();
    	const formData = new FormData(document.getElementById("registration"));
        let url = "/register";
		let inputField = ['user_type','first_name','last_name','phone','email'];
        formSubmit(url,formData,inputField,'registration');         
	}));

    function formValidations(data,rules){
        let errors = {};
        const regex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        Object.keys(rules).forEach(key => {
            validationRule = rules[key];
            value = data.get(key) ?? "";
            console.log(key,value)
            errors[key] = [];
            validationRule.forEach(rule=>{
                let ruleName ="";
                if(typeof value === 'string'){
                    ruleName = rule; 
                }else{
                    ruleName = rule['0'];
                }
                
                if(ruleName == 'required' && !value){
                    errors[key].push("This Field is required");
                }
                if(ruleName == 'email' && !regex.test(value)){
                    errors[key].push("Email  is not valid");
                }
                if(ruleName == 'min' && value.length < rule[1]){
                    errors[key].push("Minimum "+rule[1]+"characters is required");
                }
            })
        });
        return errors;
    }

    function rules(){
        return {
            first_name : ['required','email',["min",8]],
            last_name : ['required'],
            email : ['required','email'],
            user_type : ['requied'],
            phone : ['required']
        }
    }

</script>

