<?php
namespace app\src\web;
use app\src\controllers\HomeController;
use app\src\controllers\AuthController;
use app\src\controllers\TheaterController;
use app\src\controllers\PersonalController;
use app\src\controllers\MasterTablesController;

class Route{
    public $router ;
    public function __construct($route){
       $this->router = $route;  

        $this->router->get("/",[HomeController::class,"index"]);
        $this->router->get("/home",[HomeController::class,"index"]);
        $this->router->get("/login",[AuthController::class,"login"]);
        $this->router->post("/login",[AuthController::class,"login"]);
        $this->router->post("/register",[AuthController::class,"register"]);
        $this->router->get("/register",[AuthController::class,"register"]);
        $this->router->post("/verify",[AuthController::class,"verifyEmail"]);
        $this->router->get("/verify",[AuthController::class,"verifyEmail"]);
        $this->router->get("/profile",[AuthController::class,"profile"]);
        $this->router->get("/theater_renewal",[TheaterController::class,"theater_renewal"]);
        $this->router->post("/theater_renewal",[TheaterController::class,"theater_renewal"]);
        $this->router->post("/persinal_info",[PersonalController::class,"create_or_update"]);
        $this->router->post("/getStatesById",[MasterTablesController::class,"getStateByCountry"]);
        $this->router->post("/getCitiesByState",[MasterTablesController::class,"getCitiesByState"]);
        $this->router->post("/theater_renewal_docs",[TheaterController::class,"theater_renewal_docs"]);
        $this->router->post("/theater_payment",[TheaterController::class,"theater_payment"]);
        $this->router->get("/proceed",[HomeController::class,"proceed"]);
        $this->router->post("/proceed",[HomeController::class,"proceedLicense"]);
        $this->router->get("/applicationDetails",[HomeController::class,"applicationDetails"]);
        $this->router->get("/userApplicationDetails",[HomeController::class,"userApplicationDetails"]);
        $this->router->post("/remarks",[HomeController::class,"addRemarks"]);
        $this->router->post("/addQuery",[HomeController::class,"addQuery"]);
        $this->router->post("/forward",[HomeController::class,"forward"]);
        $this->router->post("/addMemo",[HomeController::class,"addMemo"]);
        $this->router->get("/logout",[AuthController::class,"logout"]);
        $this->router->get("/viewHistoryMemo",[HomeController::class,"viewHistoryMemo"]);
        $this->router->get("/viewMemo",[HomeController::class,"viewMemo"]);
        $this->router->get("/viewMemo",[HomeController::class,"viewMemo"]);
        $this->router->post("/officer_checklist",[HomeController::class,"officer_checklist"]);
        $this->router->post("/addDocs",[HomeController::class,"addDocs"]);
        $this->router->post("/removeDocs",[HomeController::class,"removeDocs"]);
        $this->router->post("/updateDocsVerification",[HomeController::class,"updateDocsVerification"]);
        $this->router->post("/approveMemo",[HomeController::class,"approveMemo"]);
        $this->router->post("/addNotes",[HomeController::class,"addNotes"]);
        $this->router->get("/viewNotes",[HomeController::class,"viewNotes"]);
        $this->router->post("/generate_pdf",[HomeController::class,"generate_pdf"]);
        $this->router->post("/addReport",[HomeController::class,"addReport"]);
        $this->router->get("/viewReports",[HomeController::class,"viewReports"]);
        $this->router->get("/notes",[HomeController::class,"notes"]);
        $this->router->post("/addMultiNotes",[HomeController::class,"addMultiNotes"]);
        $this->router->get("/report",[HomeController::class,"reports"]);
        $this->router->post("/report",[HomeController::class,"reports"]);
        $this->router->post("/reverseRemarks",[HomeController::class,"reverseRemarks"]);
    }
    

}


?>